@inline function SciMLBase.get_tmp_cache(
        integrator,
        alg::Union{
            SSPRK22, SSPRK33, SSPRK53_2N1,
            SSPRK53_2N2, SSPRK43, SSPRK432,
            SSPRK932,
        },
        cache::OrdinaryDiffEqMutableCache
    )
    return (cache.k,)
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {
        cacheType <:
        Union{
            SSPRK22, SSPRK22ConstantCache,
            SSPRK33, SSPRK33ConstantCache,
            SSPRK43, SSPRK43ConstantCache,
            SSPRK432, SSPRK432ConstantCache,
        },
    }
    return dense ? "2nd order \"free\" SSP interpolation" : "1st order linear"
end

module OrdinaryDiffEqSSPRK

import OrdinaryDiffEqCore: alg_order, calculate_residuals!,
    initialize!, perform_step!, unwrap_alg,
    calculate_residuals, ssp_coefficient,
    OrdinaryDiffEqAlgorithm,
    OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache,
    OrdinaryDiffEqNewtonAdaptiveAlgorithm,
    OrdinaryDiffEqRosenbrockAdaptiveAlgorithm,
    OrdinaryDiffEqAdaptiveAlgorithm, uses_uprev,
    alg_cache, _vec, _reshape, @cache, isfsal, full_cache,
    constvalue, _unwrap_val,
    explicit_rk_docstring, trivial_limiter!,
    _ode_interpolant, _ode_interpolant!,
    _ode_addsteps!, get_fsalfirstlast, copyat_or_push!
using FastBroadcast, Polyester, MuladdMacro, RecursiveArrayTools
using DiffEqBase: @def
using Static: False
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("ssprk_caches.jl")
include("interp_func.jl")
include("ssprk_perform_step.jl")
include("interpolants.jl")
include("addsteps.jl")
include("functions.jl")

import PrecompileTools
import Preferences
PrecompileTools.@compile_workload begin
    lorenz = OrdinaryDiffEqCore.lorenz
    lorenz_oop = OrdinaryDiffEqCore.lorenz_oop
    solver_list = []
    solver_list_nonadaptive = []
    prob_list = []

    low_storage = [
        SSPRK43(),
    ]

    low_storage_nonadaptive = [
    ]

    if Preferences.@load_preference("PrecompileLowStorage", false)
        append!(solver_list, low_storage)
        append!(solver_list_nonadaptive, low_storage_nonadaptive)
    end

    if Preferences.@load_preference("PrecompileDefaultSpecialize", true)
        push!(prob_list, ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0)))
        push!(prob_list, ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0), Float64[]))
    end

    if Preferences.@load_preference("PrecompileAutoSpecialize", false)
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.AutoSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0)
            )
        )
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.AutoSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0), Float64[]
            )
        )
    end

    if Preferences.@load_preference("PrecompileFunctionWrapperSpecialize", false)
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.FunctionWrapperSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0)
            )
        )
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.FunctionWrapperSpecialize}(
                lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0), Float64[]
            )
        )
    end

    if Preferences.@load_preference("PrecompileNoSpecialize", false)
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.NoSpecialize}(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0))
        )
        push!(
            prob_list,
            ODEProblem{true, SciMLBase.NoSpecialize}(
                lorenz, [1.0; 0.0; 0.0], (0.0, 1.0),
                Float64[]
            )
        )
    end

    for prob in prob_list, solver in solver_list
        solve(prob, solver)(5.0)
    end

    for prob in prob_list, solver in solver_list_nonadaptive
        solve(prob, solver; dt = 0.5)(5.0)
    end

    prob_list = nothing
    solver_list = nothing
end

export SSPRK53_2N2, SSPRK22, SSPRK53, SSPRK63, SSPRK83, SSPRK43, SSPRK432, SSPRKMSVS32,
    SSPRK54, SSPRK53_2N1, SSPRK104, SSPRK932, SSPRKMSVS43, SSPRK73, SSPRK53_H,
    SSPRK33, KYKSSPRK42, KYK2014DGSSPRK_3S2,
    pRRK22, pRRK33, pRRK54

end

abstract type SSPRKMutableCache <: OrdinaryDiffEqMutableCache end
abstract type SSPRKConstantCache <: OrdinaryDiffEqConstantCache end
get_fsalfirstlast(cache::SSPRKMutableCache, u) = (cache.fsalfirst, cache.k)

@cache struct SSPRK22Cache{uType, rateType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK22ConstantCache <: SSPRKConstantCache end

function alg_cache(
        alg::SSPRK22, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    return SSPRK22Cache(u, uprev, k, fsalfirst, alg.stage_limiter!, alg.step_limiter!, alg.thread)
end

function alg_cache(
        alg::SSPRK22, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK22ConstantCache()
end

@cache struct SSPRK33Cache{uType, rateType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK33ConstantCache <: SSPRKConstantCache end

function alg_cache(
        alg::SSPRK33, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    return SSPRK33Cache(u, uprev, k, fsalfirst, alg.stage_limiter!, alg.step_limiter!, alg.thread)
end

function alg_cache(
        alg::SSPRK33, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK33ConstantCache()
end

@cache struct KYKSSPRK42Cache{
        uType,
        rateType,
        TabType,
        StageLimiter,
        StepLimiter,
        Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    tmp::uType
    fsalfirst::rateType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct KYKSSPRK42ConstantCache{T, T2} <: SSPRKConstantCache
    α20::T
    α21::T
    α30::T
    α32::T
    α40::T
    α43::T
    β10::T
    β21::T
    β30::T
    β32::T
    β40::T
    β43::T
    c1::T2
    c2::T2
    c3::T2
end

function KYKSSPRK42ConstantCache(T, T2)
    α20 = T(0.394806441339829)
    α21 = T(0.605193558660171)
    α30 = T(0.00279730708739)
    α32 = T(0.99720269291261)
    α40 = T(0.252860909354373)
    α43 = T(0.747139090645627)
    β10 = T(0.406584463657504)
    β21 = T(0.246062298456822)
    β30 = T(0.013637216641451)
    β32 = T(0.405447122055692)
    β40 = T(0.016453567333598)
    β43 = T(0.303775146447707)
    c1 = T2(0.406584463657504)
    c2 = T2(0.4921245969136438)
    c3 = T2(0.9098323119879613)
    return KYKSSPRK42ConstantCache(
        α20, α21, α30, α32, α40, α43, β10, β21, β30, β32, β40, β43, c1,
        c2, c3
    )
end

function alg_cache(
        alg::KYKSSPRK42, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = KYKSSPRK42ConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return KYKSSPRK42Cache(
        u, uprev, k, tmp, fsalfirst, tab, alg.stage_limiter!, alg.step_limiter!,
        alg.thread
    )
end

function alg_cache(
        alg::KYKSSPRK42, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return KYKSSPRK42ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK53Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tmp::uType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK53ConstantCache{T, T2} <: SSPRKConstantCache
    α30::T
    α32::T
    α40::T
    α43::T
    α52::T
    α54::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2

    function SSPRK53ConstantCache(T, T2)
        α30 = T(0.355909775063327)
        α32 = T(0.644090224936674)
        α40 = T(0.367933791638137)
        α43 = T(0.632066208361863)
        α52 = T(0.237593836598569)
        α54 = T(0.762406163401431)
        β10 = T(0.377268915331368)
        β21 = T(0.377268915331368)
        β32 = T(0.242995220537396)
        β43 = T(0.23845893284629)
        β54 = T(0.287632146308408)
        c1 = T2(0.377268915331368)
        c2 = T2(0.754537830662736)
        c3 = T2(0.728985661612188)
        c4 = T2(0.69922613593167)

        return new{T, T2}(α30, α32, α40, α43, α52, α54, β10, β21, β32, β43, β54, c1, c2, c3, c4)
    end
end

function alg_cache(
        alg::SSPRK53, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = SSPRK53ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SSPRK53Cache(
        u, uprev, k, fsalfirst, tmp, tab, alg.stage_limiter!, alg.step_limiter!,
        alg.thread
    )
end

function alg_cache(
        alg::SSPRK53, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK53ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK53_2N1Cache{
        uType,
        rateType,
        TabType,
        StageLimiter,
        StepLimiter,
        Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK53_2N1ConstantCache{T, T2} <: SSPRKConstantCache
    α40::T
    α43::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2

    function SSPRK53_2N1ConstantCache(T, T2)
        α40 = T(0.571403511494104)
        α43 = T(0.428596488505896)
        β10 = T(0.443568244942995)
        β21 = T(0.291111420073766)
        β32 = T(0.270612601278217)
        β43 = T(0.110577759392786)
        β54 = T(0.458557505351052)
        c1 = T2(0.443568244942995)
        c2 = T2(0.734679665016762)
        c3 = T2(1.005292266294979)
        c4 = T2(0.541442494648948)

        return new{T, T2}(α40, α43, β10, β21, β32, β43, β54, c1, c2, c3, c4)
    end
end

function alg_cache(
        alg::SSPRK53_2N1, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = SSPRK53_2N1ConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return SSPRK53_2N1Cache(
        u, uprev, k, fsalfirst, tab, alg.stage_limiter!, alg.step_limiter!,
        alg.thread
    )
end

function alg_cache(
        alg::SSPRK53_2N1, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK53_2N1ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK53_2N2Cache{
        uType,
        rateType,
        TabType,
        StageLimiter,
        StepLimiter,
        Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK53_2N2ConstantCache{T, T2} <: SSPRKConstantCache
    α30::T
    α32::T
    α50::T
    α54::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2

    function SSPRK53_2N2ConstantCache(T, T2)
        α30 = T(0.682342861037239)
        α32 = T(0.317657138962761)
        α50 = T(0.0452309744824)
        α54 = T(0.9547690255176)
        β10 = T(0.465388589249323)
        β21 = T(0.465388589249323)
        β32 = T(0.124745797313998)
        β43 = T(0.465388589249323)
        β54 = T(0.154263303748666)
        c1 = T2(0.465388589249323)
        c2 = T2(0.930777178498646)
        c3 = T2(0.42041381284771)
        c4 = T2(0.885802402097033)

        return new{T, T2}(α30, α32, α50, α54, β10, β21, β32, β43, β54, c1, c2, c3, c4)
    end
end

function alg_cache(
        alg::SSPRK53_2N2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = SSPRK53_2N2ConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return SSPRK53_2N2Cache(
        u, uprev, k, fsalfirst, tab, alg.stage_limiter!, alg.step_limiter!,
        alg.thread
    )
end

function alg_cache(
        alg::SSPRK53_2N2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK53_2N2ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK53_HCache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tmp::uType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK53_HConstantCache{T, T2} <: SSPRKConstantCache
    α30::T
    α32::T
    α40::T
    α41::T
    α43::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2

    function SSPRK53_HConstantCache(T, T2)
        α30 = T(0.308684154602513)
        α32 = T(0.691315845397487)
        α40 = T(0.280514990468574)
        α41 = T(0.270513101776498)
        α43 = T(0.448971907754928)
        β10 = T(0.377268915331368)
        β21 = T(0.377268915331368)
        β32 = T(0.260811979144498)
        β43 = T(0.169383144652957)
        β54 = T(0.377268915331368)
        c1 = T2(0.377268915331368)
        c2 = T2(0.754537830662737)
        c3 = T2(0.782435937433493)
        c4 = T2(0.622731084668631)

        return new{T, T2}(α30, α32, α40, α41, α43, β10, β21, β32, β43, β54, c1, c2, c3, c4)
    end
end

function alg_cache(
        alg::SSPRK53_H, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = SSPRK53_HConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SSPRK53_HCache(
        u, uprev, k, fsalfirst, tmp, tab, alg.stage_limiter!, alg.step_limiter!,
        alg.thread
    )
end

function alg_cache(
        alg::SSPRK53_H, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK53_HConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK63Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tmp::uType
    u₂::uType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK63ConstantCache{T, T2} <: SSPRKConstantCache
    α40::T
    α41::T
    α43::T
    α62::T
    α65::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    β65::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2
    c5::T2

    function SSPRK63ConstantCache(T, T2)
        α40 = T(0.476769811285196)
        α41 = T(0.098511733286064)
        α43 = T(0.42471845542874)
        α62 = T(0.155221702560091)
        α65 = T(0.844778297439909)
        β10 = T(0.284220721334261)
        β21 = T(0.284220721334261)
        β32 = T(0.284220721334261)
        β43 = T(0.12071378576593)
        β54 = T(0.284220721334261)
        β65 = T(0.2401034970659)
        c1 = T2(0.284220721334261)
        c2 = T2(0.568441442668522)
        c3 = T2(0.852662164002783)
        c4 = T2(0.510854218958172)
        c5 = T2(0.795074940292433)

        return new{T, T2}(
            α40, α41, α43, α62, α65, β10, β21, β32, β43, β54, β65, c1, c2, c3, c4,
            c5
        )
    end
end

function alg_cache(
        alg::SSPRK63, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    u₂ = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = SSPRK63ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SSPRK63Cache(
        u, uprev, k, fsalfirst, tmp, u₂, tab, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::SSPRK63, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK63ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK73Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tmp::uType
    u₁::uType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK73ConstantCache{T, T2} <: SSPRKConstantCache
    α40::T
    α43::T
    α50::T
    α51::T
    α54::T
    α73::T
    α76::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    β65::T
    β76::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2
    c5::T2
    c6::T2

    function SSPRK73ConstantCache(T, T2)
        α40 = T(0.184962588071072)
        α43 = T(0.815037411928928)
        α50 = T(0.18071865657038)
        α51 = T(0.314831034403793)
        α54 = T(0.504450309025826)
        α73 = T(0.120199)
        α76 = T(0.879801)
        β10 = T(0.233213863663009)
        β21 = T(0.233213863663009)
        β32 = T(0.233213863663009)
        β43 = T(0.190078023865845)
        β54 = T(0.117644805593912)
        β65 = T(0.233213863663009)
        β76 = T(0.205181790464579)
        c1 = T2(0.233213863663009)
        c2 = T2(0.466427727326018)
        c3 = T2(0.699641590989027)
        c4 = T2(0.760312095463379)
        c5 = T2(0.574607439040817)
        c6 = T2(0.807821302703826)

        return new{T, T2}(
            α40, α43, α50, α51, α54, α73, α76, β10, β21, β32, β43, β54, β65, β76, c1,
            c2, c3, c4, c5, c6
        )
    end
end

function alg_cache(
        alg::SSPRK73, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    u₁ = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = SSPRK73ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SSPRK73Cache(
        u, uprev, k, fsalfirst, tmp, u₁, tab, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::SSPRK73, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK73ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK83Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tmp::uType
    u₂::uType
    u₃::uType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK83ConstantCache{T, T2} <: SSPRKConstantCache
    α50::T
    α51::T
    α54::T
    α61::T
    α65::T
    α72::T
    α73::T
    α76::T
    β10::T
    β21::T
    β32::T
    β43::T
    β54::T
    β65::T
    β76::T
    β87::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2
    c5::T2
    c6::T2
    c7::T2

    function SSPRK83ConstantCache(T, T2)
        α50 = T(0.421366967085359)
        α51 = T(0.005949401107575)
        α54 = T(0.572683631807067)
        α61 = T(0.004254010666365)
        α65 = T(0.995745989333635)
        α72 = T(0.104380143093325)
        α73 = T(0.243265240906726)
        α76 = T(0.65235461599995)
        β10 = T(0.195804015330143)
        β21 = T(0.195804015330143)
        β32 = T(0.195804015330143)
        β43 = T(0.195804015330143)
        β54 = T(0.112133754621673)
        β65 = T(0.194971062960412)
        β76 = T(0.127733653231944)
        β87 = T(0.195804015330143)
        c1 = T2(0.195804015330143)
        c2 = T2(0.391608030660286)
        c3 = T2(0.587412045990429)
        c4 = T2(0.783216061320572)
        c5 = T2(0.561833689734037)
        c6 = T2(0.755247658555329)
        c7 = T2(0.804195984669857)

        return new{T, T2}(
            α50, α51, α54, α61, α65, α72, α73, α76, β10, β21, β32, β43, β54, β65,
            β76, β87, c1, c2, c3, c4, c5, c6, c7
        )
    end
end

function alg_cache(
        alg::SSPRK83, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    u₂ = zero(u)
    u₃ = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = SSPRK83ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SSPRK83Cache(
        u, uprev, k, fsalfirst, tmp, u₂, u₃, tab, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::SSPRK83, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK83ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK43Cache{
        uType, rateType, uNoUnitsType, TabType, StageLimiter,
        StepLimiter, Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    utilde::uType
    atmp::uNoUnitsType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK43ConstantCache{T, T2} <: SSPRKConstantCache
    one_third_u::T
    two_thirds_u::T
    half_u::T
    half_t::T2

    function SSPRK43ConstantCache(T, T2)
        one_third_u = inv(T(3))
        two_thirds_u = 2 * one_third_u
        half_u = T(0.5)
        half_t = T2(0.5)

        return new{T, T2}(one_third_u, two_thirds_u, half_u, half_t)
    end
end

function alg_cache(
        alg::SSPRK43, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tab = SSPRK43ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SSPRK43Cache(
        u, uprev, k, fsalfirst, utilde, atmp, tab, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::SSPRK43, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK43ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK432Cache{
        uType,
        rateType,
        uNoUnitsType,
        StageLimiter,
        StepLimiter,
        Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    utilde::uType
    atmp::uNoUnitsType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK432ConstantCache <: SSPRKConstantCache end

function alg_cache(
        alg::SSPRK432, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    return SSPRK432Cache(
        u, uprev, k, fsalfirst, utilde, atmp, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::SSPRK432, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK432ConstantCache()
end

@cache mutable struct SSPRKMSVS32Cache{
        uType, rateType, dtArrayType, dtType, StageLimiter,
        StepLimiter, Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    u_2::uType
    u_1::uType
    k::rateType
    tmp::uType
    dts::dtArrayType
    dtf::dtArrayType
    μ::dtType
    v_n::Float64
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    step::Int
end

@cache mutable struct SSPRKMSVS32ConstantCache{uType, dtArrayType, dtType} <:
    OrdinaryDiffEqConstantCache
    u_2::uType
    u_1::uType
    dts::dtArrayType
    dtf::dtArrayType
    μ::dtType
    v_n::Float64
    step::Int
end

function alg_cache(
        alg::SSPRKMSVS32, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    dts = fill(zero(dt), 3)
    dtf = fill(zero(dt), 2)
    μ = zero(dt)
    u_2 = zero(u)
    u_1 = zero(u)
    k = zero(rate_prototype)
    tmp = zero(u)
    return SSPRKMSVS32Cache(
        u, uprev, fsalfirst, u_2, u_1, k, tmp, dts, dtf, μ, 0.5,
        alg.stage_limiter!, alg.step_limiter!, alg.thread, 1
    )
end

function alg_cache(
        alg::SSPRKMSVS32, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(dt), 3)
    dtf = fill(zero(dt), 2)
    μ = zero(dt)
    u_2 = u
    u_1 = u
    return SSPRKMSVS32ConstantCache(u_2, u_1, dts, dtf, μ, 0.5, 1)
end

@cache mutable struct SSPRKMSVS43Cache{
        uType,
        rateType,
        StageLimiter,
        StepLimiter,
        Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    u_3::uType
    u_2::uType
    u_1::uType
    k::rateType
    k1::rateType
    k2::rateType
    k3::rateType
    tmp::uType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    step::Int
end

@cache mutable struct SSPRKMSVS43ConstantCache{uType, rateType} <:
    OrdinaryDiffEqConstantCache
    u_3::uType
    u_2::uType
    u_1::uType
    k1::rateType
    k2::rateType
    k3::rateType
    step::Int
end

function alg_cache(
        alg::SSPRKMSVS43, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    u_3 = zero(u)
    u_2 = zero(u)
    u_1 = zero(u)
    k = zero(rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    tmp = zero(u)
    return SSPRKMSVS43Cache(
        u, uprev, fsalfirst, u_3, u_2, u_1, k, k1, k2, k3, tmp,
        alg.stage_limiter!, alg.step_limiter!, alg.thread, 1
    )
end

function alg_cache(
        alg::SSPRKMSVS43, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    u_3 = u
    u_2 = u
    u_1 = u
    k1 = rate_prototype
    k2 = rate_prototype
    k3 = rate_prototype
    return SSPRKMSVS43ConstantCache(u_3, u_2, u_1, k1, k2, k3, 1)
end

@cache struct SSPRK932Cache{
        uType,
        rateType,
        uNoUnitsType,
        StageLimiter,
        StepLimiter,
        Thread,
    } <: SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    utilde::uType
    atmp::uNoUnitsType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK932ConstantCache <: SSPRKConstantCache end

function alg_cache(
        alg::SSPRK932, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    utilde = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    return SSPRK932Cache(
        u, uprev, k, fsalfirst, utilde, atmp, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::SSPRK932, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK932ConstantCache()
end

@cache struct SSPRK54Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    k₃::rateType
    u₂::uType
    u₃::uType
    tmp::uType # should be u₄, but tmp is needed for callbacks
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK54ConstantCache{T, T2} <: SSPRKConstantCache
    β10::T
    α20::T
    α21::T
    β21::T
    α30::T
    α32::T
    β32::T
    α40::T
    α43::T
    β43::T
    α52::T
    α53::T
    β53::T
    α54::T
    β54::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2

    function SSPRK54ConstantCache(T, T2)
        β10 = T(0.39175222657189)
        α20 = T(0.444370493651235)
        α21 = T(0.555629506348765)
        β21 = T(0.368410593050371)
        α30 = T(0.620101851488403)
        α32 = T(0.379898148511597)
        β32 = T(0.251891774271694)
        α40 = T(0.178079954393132)
        α43 = T(0.821920045606868)
        β43 = T(0.544974750228521)
        α52 = T(0.517231671970585)
        α53 = T(0.096059710526147)
        β53 = T(0.06369246866629)
        α54 = T(0.386708617503269)
        β54 = T(0.226007483236906)
        c1 = T2(0.39175222657189)
        c2 = T2(0.58607968931154)
        c3 = T2(0.4745423631214)
        c4 = T2(0.935010630967653)

        return new{T, T2}(
            β10, α20, α21, β21, α30, α32, β32, α40, α43, β43, α52, α53, β53, α54,
            β54, c1, c2, c3, c4
        )
    end
end

function alg_cache(
        alg::SSPRK54, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    u₂ = zero(u)
    u₃ = zero(u)
    tmp = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    k₃ = zero(rate_prototype)
    tab = SSPRK54ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SSPRK54Cache(
        u, uprev, k, fsalfirst, k₃, u₂, u₃, tmp, tab, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::SSPRK54, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK54ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SSPRK104Cache{uType, rateType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    k₄::rateType
    tmp::uType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct SSPRK104ConstantCache <: SSPRKConstantCache end

function alg_cache(
        alg::SSPRK104, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    k₄ = zero(rate_prototype)
    return SSPRK104Cache(
        u, uprev, k, fsalfirst, k₄, tmp, alg.stage_limiter!, alg.step_limiter!,
        alg.thread
    )
end

function alg_cache(
        alg::SSPRK104, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SSPRK104ConstantCache()
end

@cache struct KYK2014DGSSPRK_3S2_Cache{
        uType, rateType, TabType, StageLimiter, StepLimiter,
        Thread,
    } <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tab::TabType
    #temporary values for Shu-Osher
    u_1::uType
    u_2::uType
    kk_1::rateType
    kk_2::rateType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

struct KYK2014DGSSPRK_3S2_ConstantCache{T, T2} <: OrdinaryDiffEqConstantCache
    #These are not α and β for RK but for Shu-Osher
    #see top of page 317 in
    #Optimal Strong-Stability-Preserving Runge–Kutta Time Discretizations for
    #Discontinuous Garlekin Methods, Kubatko, Yaeger, Ketcheson 2014
    α_10::T
    α_20::T
    α_21::T
    α_30::T
    α_32::T
    β_10::T
    β_21::T
    β_30::T
    β_32::T
    #Shu-Osher is normally stated for autonomous systems, the times
    #are calculated by hand for this scheme
    c_1::T
    c_2::T

    function KYK2014DGSSPRK_3S2_ConstantCache(T, T2)
        α_10 = T(1.0)
        α_20 = T(0.087353119859156)
        α_21 = T(0.912646880140844)
        α_30 = T(0.344956917166841)
        α_32 = T(0.655043082833159)
        β_10 = T(0.528005024856522)
        β_21 = T(0.481882138633993)
        β_30 = T(0.022826837460491)
        β_32 = T(0.345866039233415)
        c_1 = β_10
        c_2 = α_21 * β_10 + β_21 # ==0.96376427726
        return new{T, T2}(α_10, α_20, α_21, α_30, α_32, β_10, β_21, β_30, β_32, c_1, c_2)
    end
end

function alg_cache(
        alg::KYK2014DGSSPRK_3S2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    u_1 = zero(u)
    u_2 = zero(u)
    kk_1 = zero(rate_prototype)
    kk_2 = zero(rate_prototype)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = KYK2014DGSSPRK_3S2_ConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return KYK2014DGSSPRK_3S2_Cache(
        u, uprev, k, fsalfirst, tab, u_1, u_2, kk_1, kk_2,
        alg.stage_limiter!, alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::KYK2014DGSSPRK_3S2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return KYK2014DGSSPRK_3S2_ConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
end

# pRRK caches
# Parametric Relaxation Runge-Kutta methods (Liu et al. 2023)
# These store base Shu-Osher coefficients (α, β) and the stabilization parameter κ.
# Modified coefficients (α̂, β̂) are computed in perform_step! based on κ·Δt.

# pRRK22: Based on Heun's method / SSPRK(2,2)
# Shu-Osher form:
#   u₁ = u₀ + Δt f(u₀)
#   u₂ = ½u₀ + ½u₁ + ½Δt f(u₁)
# α = [1 0; 1/2 1/2], β = [1 0; 0 1/2]
struct pRRK22ConstantCache{T, T2} <: SSPRKConstantCache
    κ::T
    # Base Shu-Osher coefficients (stored for clarity)
    α10::T
    β10::T
    α20::T
    α21::T
    β21::T

    function pRRK22ConstantCache(T, T2, κ)
        α10 = T(1)
        β10 = T(1)
        α20 = T(1 // 2)
        α21 = T(1 // 2)
        β21 = T(1 // 2)
        return new{T, T2}(T(κ), α10, β10, α20, α21, β21)
    end
end

@cache struct pRRK22Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

function alg_cache(
        alg::pRRK22, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = pRRK22ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits), alg.kappa)
    return pRRK22Cache(u, uprev, k, fsalfirst, tab, alg.stage_limiter!, alg.step_limiter!, alg.thread)
end

function alg_cache(
        alg::pRRK22, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return pRRK22ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits), alg.kappa)
end

# pRRK33: Based on SSPRK(3,3)
# Shu-Osher form:
#   u₁ = u₀ + Δt f(u₀)
#   u₂ = ¾u₀ + ¼u₁ + ¼Δt f(u₁)
#   u₃ = ⅓u₀ + ⅔u₂ + ⅔Δt f(u₂)
# α = [1 0 0; 3/4 1/4 0; 1/3 0 2/3], β = [1 0 0; 0 1/4 0; 0 0 2/3]
struct pRRK33ConstantCache{T, T2} <: SSPRKConstantCache
    κ::T
    α10::T
    β10::T
    α20::T
    α21::T
    β21::T
    α30::T
    α32::T
    β32::T

    function pRRK33ConstantCache(T, T2, κ)
        α10 = T(1)
        β10 = T(1)
        α20 = T(3 // 4)
        α21 = T(1 // 4)
        β21 = T(1 // 4)
        α30 = T(1 // 3)
        α32 = T(2 // 3)
        β32 = T(2 // 3)
        return new{T, T2}(T(κ), α10, β10, α20, α21, β21, α30, α32, β32)
    end
end

@cache struct pRRK33Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

function alg_cache(
        alg::pRRK33, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    tab = pRRK33ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits), alg.kappa)
    return pRRK33Cache(u, uprev, k, fsalfirst, tab, alg.stage_limiter!, alg.step_limiter!, alg.thread)
end

function alg_cache(
        alg::pRRK33, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return pRRK33ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits), alg.kappa)
end

# pRRK54: Based on Spiteri-Ruuth SSPRK(5,4)
# Uses the same base Shu-Osher coefficients as SSPRK54
struct pRRK54ConstantCache{T, T2} <: SSPRKConstantCache
    κ::T
    β10::T
    α20::T
    α21::T
    β21::T
    α30::T
    α32::T
    β32::T
    α40::T
    α43::T
    β43::T
    α52::T
    α53::T
    β53::T
    α54::T
    β54::T
    c1::T2
    c2::T2
    c3::T2
    c4::T2

    function pRRK54ConstantCache(T, T2, κ)
        β10 = T(0.39175222657189)
        α20 = T(0.444370493651235)
        α21 = T(0.555629506348765)
        β21 = T(0.368410593050371)
        α30 = T(0.620101851488403)
        α32 = T(0.379898148511597)
        β32 = T(0.251891774271694)
        α40 = T(0.178079954393132)
        α43 = T(0.821920045606868)
        β43 = T(0.544974750228521)
        α52 = T(0.517231671970585)
        α53 = T(0.096059710526147)
        β53 = T(0.06369246866629)
        α54 = T(0.386708617503269)
        β54 = T(0.226007483236906)
        c1 = T2(0.39175222657189)
        c2 = T2(0.58607968931154)
        c3 = T2(0.4745423631214)
        c4 = T2(0.935010630967653)

        return new{T, T2}(
            T(κ), β10, α20, α21, β21, α30, α32, β32, α40, α43, β43, α52, α53, β53, α54,
            β54, c1, c2, c3, c4
        )
    end
end

@cache struct pRRK54Cache{uType, rateType, TabType, StageLimiter, StepLimiter, Thread} <:
    SSPRKMutableCache
    u::uType
    uprev::uType
    k::rateType
    fsalfirst::rateType
    k₃::rateType
    u₂::uType
    u₃::uType
    tmp::uType
    tab::TabType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

function alg_cache(
        alg::pRRK54, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    u₂ = zero(u)
    u₃ = zero(u)
    tmp = zero(u)
    k = zero(rate_prototype)
    if calck
        fsalfirst = zero(k)
    else
        fsalfirst = k
    end
    k₃ = zero(rate_prototype)
    tab = pRRK54ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits), alg.kappa)
    return pRRK54Cache(
        u, uprev, k, fsalfirst, k₃, u₂, u₃, tmp, tab, alg.stage_limiter!,
        alg.step_limiter!, alg.thread
    )
end

function alg_cache(
        alg::pRRK54, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return pRRK54ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits), alg.kappa)
end

@doc explicit_rk_docstring(
    "A third-order, five-stage explicit strong stability preserving (SSP) low-storage method.
Fixed timestep only.",
    "SSPRK53_2N2",
    references = "Higueras and T. Roldán.
    New third order low-storage SSP explicit Runge–Kutta methods
    arXiv:1809.04807v1."
)
Base.@kwdef struct SSPRK53_2N2{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK53_2N2(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK53_2N2(
        stage_limiter!,
        step_limiter!,
        False()
    )
end

@doc explicit_rk_docstring(
    "A second-order, two-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK22",
    references = "Shu, Chi-Wang, and Stanley Osher.
    Efficient implementation of essentially non-oscillatory shock-capturing schemes.
    Journal of Computational Physics 77.2 (1988): 439-471.
    https://doi.org/10.1016/0021-9991(88)90177-5"
)
Base.@kwdef struct SSPRK22{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK22(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK22(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, five-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK53",
    references = "Ruuth, Steven.
    Global optimization of explicit strong-stability-preserving Runge-Kutta methods.
    Mathematics of Computation 75.253 (2006): 183-207"
)
Base.@kwdef struct SSPRK53{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK53(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK53(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, six-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK63",
    references = "Ruuth, Steven.
    Global optimization of explicit strong-stability-preserving Runge-Kutta methods.
    Mathematics of Computation 75.253 (2006): 183-207"
)
Base.@kwdef struct SSPRK63{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK63(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK63(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, eight-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK83",
    references = "Ruuth, Steven.
    Global optimization of explicit strong-stability-preserving Runge-Kutta methods.
    Mathematics of Computation 75.253 (2006): 183-207"
)
Base.@kwdef struct SSPRK83{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK83(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK83(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, four-stage explicit strong stability preserving (SSP) method.",
    "SSPRK43",
    references = """Optimal third-order explicit SSP method with four stages discovered by

      - J. F. B. M. Kraaijevanger.
        "Contractivity of Runge-Kutta methods."
        In: BIT Numerical Mathematics 31.3 (1991), pp. 482–528.
        [DOI: 10.1007/BF01933264](https://doi.org/10.1007/BF01933264).

    Embedded method constructed by

      - Sidafa Conde, Imre Fekete, John N. Shadid.
        "Embedded error estimation and adaptive step-size control for
        optimal explicit strong stability preserving Runge–Kutta methods."
        [arXiv: 1806.08693](https://arXiv.org/abs/1806.08693)

    Efficient implementation (and optimized controller) developed by

      - Hendrik Ranocha, Lisandro Dalcin, Matteo Parsani, David I. Ketcheson (2021)
        Optimized Runge-Kutta Methods with Automatic Step Size Control for
        Compressible Computational Fluid Dynamics
        [arXiv:2104.06836](https://arxiv.org/abs/2104.06836)"""
)
Base.@kwdef struct SSPRK43{StageLimiter, StepLimiter, Thread} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK43(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK43(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, four-stage explicit strong stability preserving (SSP) method.",
    "SSPRK432",
    references = "Gottlieb, Sigal, David I. Ketcheson, and Chi-Wang Shu.
    Strong stability preserving Runge-Kutta and multistep time discretizations.
    World Scientific, 2011.
    Example 6.1"
)
Base.@kwdef struct SSPRK432{StageLimiter, StepLimiter, Thread} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK432(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK432(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A second-order, three-step explicit strong stability preserving (SSP) linear multistep method.
This method does not come with an error estimator and requires a fixed time step
size.",
    "SSPRKMSVS32",
    references = "Shu, Chi-Wang.
    Total-variation-diminishing time discretizations.
    SIAM Journal on Scientific and Statistical Computing 9, no. 6 (1988): 1073-1084.
    [DOI: 10.1137/0909073](https://doi.org/10.1137/0909073)"
)
Base.@kwdef struct SSPRKMSVS32{StageLimiter, StepLimiter, Thread} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRKMSVS32(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRKMSVS32(
        stage_limiter!,
        step_limiter!,
        False()
    )
end

@doc explicit_rk_docstring(
    "A fourth-order, five-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK54",
    references = "Ruuth, Steven.
    Global optimization of explicit strong-stability-preserving Runge-Kutta methods.
    Mathematics of Computation 75.253 (2006): 183-207."
)
Base.@kwdef struct SSPRK54{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK54(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK54(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, five-stage explicit strong stability preserving (SSP) low-storage method.
Fixed timestep only.",
    "SSPRK53_2N1",
    references = "Higueras and T. Roldán.
    New third order low-storage SSP explicit Runge–Kutta methods
    arXiv:1809.04807v1."
)
Base.@kwdef struct SSPRK53_2N1{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK53_2N1(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK53_2N1(
        stage_limiter!,
        step_limiter!,
        False()
    )
end

@doc explicit_rk_docstring(
    "A fourth-order, ten-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK104",
    references = "Ketcheson, David I.
    Highly efficient strong stability-preserving Runge–Kutta methods with
    low-storage implementations.
    SIAM Journal on Scientific Computing 30.4 (2008): 2113-2136."
)
Base.@kwdef struct SSPRK104{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK104(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK104(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, nine-stage explicit strong stability preserving (SSP) method.

Consider using `SSPRK43` instead, which uses the same main method and an
improved embedded method.",
    "SSPRK932",
    references = "Gottlieb, Sigal, David I. Ketcheson, and Chi-Wang Shu.
    Strong stability preserving Runge-Kutta and multistep time discretizations.
    World Scientific, 2011."
)
Base.@kwdef struct SSPRK932{StageLimiter, StepLimiter, Thread} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK932(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK932(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, four-step explicit strong stability preserving (SSP) linear multistep method.
This method does not come with an error estimator and requires a fixed time step
size.",
    "SSPRKMSVS43",
    references = "Shu, Chi-Wang.
    Total-variation-diminishing time discretizations.
    SIAM Journal on Scientific and Statistical Computing 9, no. 6 (1988): 1073-1084.
    [DOI: 10.1137/0909073](https://doi.org/10.1137/0909073)"
)
Base.@kwdef struct SSPRKMSVS43{StageLimiter, StepLimiter, Thread} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRKMSVS43(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRKMSVS43(
        stage_limiter!,
        step_limiter!,
        False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, seven-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK73",
    references = "Ruuth, Steven.
    Global optimization of explicit strong-stability-preserving Runge-Kutta methods.
    Mathematics of Computation 75.253 (2006): 183-207"
)
Base.@kwdef struct SSPRK73{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK73(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK73(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, five-stage explicit strong stability preserving (SSP) low-storage method.
Fixed timestep only.",
    "SSPRK53_H",
    references = "Higueras and T. Roldán.
    New third order low-storage SSP explicit Runge–Kutta methods
    arXiv:1809.04807v1."
)
Base.@kwdef struct SSPRK53_H{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK53_H(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK53_H(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "A third-order, three-stage explicit strong stability preserving (SSP) method.
Fixed timestep only.",
    "SSPRK33",
    references = "Shu, Chi-Wang, and Stanley Osher.
    Efficient implementation of essentially non-oscillatory shock-capturing schemes.
    Journal of Computational Physics 77.2 (1988): 439-471.
    https://doi.org/10.1016/0021-9991(88)90177-5"
)
Base.@kwdef struct SSPRK33{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SSPRK33(stage_limiter!, step_limiter! = trivial_limiter!)
    return SSPRK33(
        stage_limiter!,
        step_limiter!, False()
    )
end

@doc explicit_rk_docstring(
    "Optimal strong-stability-preserving Runge-Kutta time discretizations for discontinuous Galerkin methods",
    "KYKSSPRK42",
    references = "@article{kubatko2014optimal,
    title={Optimal strong-stability-preserving Runge--Kutta time discretizations for discontinuous Galerkin methods},
    author={Kubatko, Ethan J and Yeager, Benjamin A and Ketcheson, David I},
    journal={Journal of Scientific Computing},
    volume={60},
    pages={313--344},
    year={2014},
    publisher={Springer}}"
)
Base.@kwdef struct KYKSSPRK42{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function KYKSSPRK42(stage_limiter!, step_limiter! = trivial_limiter!)
    return KYKSSPRK42(
        stage_limiter!,
        step_limiter!,
        False()
    )
end

@doc explicit_rk_docstring(
    "Optimal strong-stability-preserving Runge-Kutta time discretizations for discontinuous Galerkin methods",
    "KYK2014DGSSPRK_3S2",
    references = """@article{kubatko2014optimal,
    title={Optimal strong-stability-preserving Runge--Kutta time discretizations for discontinuous Galerkin methods},
    author={Kubatko, Ethan J and Yeager, Benjamin A and Ketcheson, David I},
    journal={Journal of Scientific Computing},
    volume={60},
    pages={313--344},
    year={2014},
    publisher={Springer}}"""
)
Base.@kwdef struct KYK2014DGSSPRK_3S2{StageLimiter, StepLimiter, Thread} <:
    OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function KYK2014DGSSPRK_3S2(stage_limiter!, step_limiter! = trivial_limiter!)
    return KYK2014DGSSPRK_3S2(
        stage_limiter!,
        step_limiter!,
        False()
    )
end

@doc explicit_rk_docstring(
    "Parametric relaxation Runge-Kutta method based on Heun's method (SSPRK(2,2)).
The parametric stabilization adds a term κ(u - u) to the ODE, modifying
Shu-Osher coefficients to enhance stability for large time steps.
SSP coefficient C = 1. The parameter `kappa` controls the stabilization strength;
when `kappa = 0`, this reduces to standard SSPRK22.
Fixed timestep only.",
    "pRRK22",
    references = """@article{liu2023high,
    title={High-order, large time-stepping integrators for scalar hyperbolic conservation laws},
    author={Liu, Lele and Burchard, Hans and Kuzmin, Dmitri and Shang, Sijun},
    year={2023},
    note={SSRN preprint 4401014}}"""
)
Base.@kwdef struct pRRK22{T, StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    kappa::T = 0.0
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end

@doc explicit_rk_docstring(
    "Parametric relaxation Runge-Kutta method based on RK(3,3) (SSPRK(3,3)).
The parametric stabilization adds a term κ(u - u) to the ODE, modifying
Shu-Osher coefficients to enhance stability for large time steps.
SSP coefficient C = 1. The parameter `kappa` controls the stabilization strength;
when `kappa = 0`, this reduces to standard SSPRK33.
Fixed timestep only.",
    "pRRK33",
    references = """@article{liu2023high,
    title={High-order, large time-stepping integrators for scalar hyperbolic conservation laws},
    author={Liu, Lele and Burchard, Hans and Kuzmin, Dmitri and Shang, Sijun},
    year={2023},
    note={SSRN preprint 4401014}}"""
)
Base.@kwdef struct pRRK33{T, StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    kappa::T = 0.0
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end

@doc explicit_rk_docstring(
    "Parametric relaxation Runge-Kutta method based on Spiteri-Ruuth RK(5,4) (SSPRK(5,4)).
The parametric stabilization adds a term κ(u - u) to the ODE, modifying
Shu-Osher coefficients to enhance stability for large time steps.
SSP coefficient C ≈ 1.508. The parameter `kappa` controls the stabilization strength;
when `kappa = 0`, this reduces to standard SSPRK54.
Fixed timestep only.",
    "pRRK54",
    references = """@article{liu2023high,
    title={High-order, large time-stepping integrators for scalar hyperbolic conservation laws},
    author={Liu, Lele and Burchard, Hans and Kuzmin, Dmitri and Shang, Sijun},
    year={2023},
    note={SSRN preprint 4401014}}"""
)
Base.@kwdef struct pRRK54{T, StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    kappa::T = 0.0
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end

function _ode_addsteps!(
        k, t, uprev, u, dt, f, p,
        cache::Union{
            SSPRK22ConstantCache, SSPRK33ConstantCache,
            SSPRK43ConstantCache, SSPRK432ConstantCache,
        },
        always_calc_begin = false, allow_calc_end = true,
        force_calc_end = false
    )
    if length(k) < 1 || always_calc_begin
        copyat_or_push!(k, 1, f(uprev, p, t))
    end
    return nothing
end

function _ode_addsteps!(
        k, t, uprev, u, dt, f, p,
        cache::Union{
            SSPRK22Cache, SSPRK33Cache, SSPRK43Cache,
            SSPRK432Cache,
        }, always_calc_begin = false,
        allow_calc_end = true, force_calc_end = false
    )
    if length(k) < 1 || always_calc_begin
        f(cache.k, uprev, p, t)
        copyat_or_push!(k, 1, cache.k)
    end
    return nothing
end

using OrdinaryDiffEqSSPRK, DiffEqDevTools, Test, Random
import OrdinaryDiffEqLowStorageRK
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear, prob_ode_bigfloat2Dlinear

Random.seed!(100)

dts = 1 .// 2 .^ (8:-1:4)
testTol = 0.25

f = (u, p, t) -> cos(t)
prob_ode_sin = ODEProblem(ODEFunction(f; analytic = (u0, p, t) -> sin(t)), 0.0, (0.0, 1.0))

f = (du, u, p, t) -> du[1] = cos(t)
prob_ode_sin_inplace = ODEProblem(
    ODEFunction(f; analytic = (u0, p, t) -> [sin(t)]), [0.0],
    (0.0, 1.0)
)

f = (u, p, t) -> sin(u)
prob_ode_nonlinear = ODEProblem(
    ODEFunction(
        f;
        analytic = (u0, p, t) -> 2 * acot(
            exp(-t) *
                cot(0.5)
        )
    ), 1.0,
    (0.0, 0.5)
)

f = (du, u, p, t) -> du[1] = sin(u[1])
prob_ode_nonlinear_inplace = ODEProblem(
    ODEFunction(
        f;
        analytic = (u0, p, t) -> [
            2 * acot(exp(-t) * cot(0.5)),
        ]
    ),
    [1.0], (0.0, 0.5)
)

test_problems_only_time = [prob_ode_sin, prob_ode_sin_inplace]
test_problems_linear = [prob_ode_linear, prob_ode_2Dlinear, prob_ode_bigfloat2Dlinear]
test_problems_nonlinear = [prob_ode_nonlinear, prob_ode_nonlinear_inplace]

f_ssp = (u, p, t) -> begin
    sin(10t) * u * (1 - u)
end
test_problem_ssp = ODEProblem(f_ssp, 0.1, (0.0, 8.0))
test_problem_ssp_long = ODEProblem(f_ssp, 0.1, (0.0, 1.0e3))

f_ssp_inplace = (du, u, p, t) -> begin
    @. du = sin(10t) * u * (1 - u)
end
test_problem_ssp_inplace = ODEProblem(f_ssp_inplace, rand(3, 3), (0.0, 8.0))

# Test the memory usage, cf. #640
# Note: Basically, the size of the integrator should be the size of the cache
# plus the size of the initial condition, stored is integ.sol.prob.u0.
u0_large = rand(10^6)
prob_ode_large = ODEProblem((du, u, p, t) -> du .= u, u0_large, (0.0, 1.0))

println("SSPRK22")
alg = SSPRK22()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test SSP property of dense output
sol = solve(test_problem_ssp, alg, dt = 1.0)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
sol = solve(test_problem_ssp_inplace, alg, dt = 1.0)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3

println("KYKSSPRK42")
alg = KYKSSPRK42()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)

println("SSPRK33")
alg = SSPRK33()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    # This corresponds to Simpson's rule; due to symmetric quadrature nodes,
    # it is of degree 4 instead of 3, as would be expected.
    @test abs(sim.𝒪est[:final] - 1 - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test SSP property of dense output
sol = solve(test_problem_ssp, alg, dt = 1.0)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
sol = solve(test_problem_ssp_inplace, alg, dt = 1.0)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3

println("SSPRK53")
alg = SSPRK53()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4

println("SSPRK53_2N1")
alg = SSPRK53_2N1()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3

# for SSPRK53_2N2 to be in asymptotic range
dts = 1 .// 2 .^ (9:-1:5)
println("SSPRK53_2N2")
alg = SSPRK53_2N2()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3

dts = 1 .// 2 .^ (9:-1:5)
println("SSPRK53_H")
alg = SSPRK53_H()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = 0.4
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = 0.4
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = 0.4
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4

#reverting back to original dts
println("SSPRK63")
dts = 1 .// 2 .^ (8:-1:4)
alg = SSPRK63()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)

println("SSPRK73")
alg = SSPRK73()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)

println("SSPRK83")
alg = SSPRK83()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)

println("SSPRK43")
alg = SSPRK43()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    # higher order as pure quadrature
    @test abs(sim.𝒪est[:final] - 1 - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test SSP property of dense output
sol = solve(test_problem_ssp, alg, dt = 8 / 5, adaptive = false)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
sol = solve(test_problem_ssp_inplace, alg, dt = 8 / 5, adaptive = false)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5

println("SSPRK432")
alg = SSPRK432()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    # higher order as pure quadrature
    @test abs(sim.𝒪est[:final] - 1 - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test SSP property of dense output
sol = solve(test_problem_ssp, alg, dt = 8 / 5, adaptive = false)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
sol = solve(test_problem_ssp_inplace, alg, dt = 8 / 5, adaptive = false)
@test mapreduce(
    t -> all(0 .<= sol(t) .<= 1), (u, v) -> u && v,
    range(0, stop = 8, length = 50), init = true
)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5

alg = SSPRKMSVS32()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end

println("SSPRKMSVS43")
alg = SSPRKMSVS43()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg) #shows superconvergence to 4th order
    @test abs(sim.𝒪est[:final] - 1 - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end

println("SSPRK932")
alg = SSPRK932()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false, maxiters = 1.0e7
)
@test all(sol.u .>= 0)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5

println("SSPRK54")
alg = SSPRK54()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    # convergence order seems to be worse for this problem
    @test abs(sim.𝒪est[:final] + 0.25 - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    # convergence order seems to be better for this problem
    @test abs(sim.𝒪est[:final] - 0.5 - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)

println("SSPRK104")
alg = SSPRK104()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqSSPRK.alg_order(alg) atol = testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)
# test storage
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
integ = init(
    prob_ode_large, alg, dt = 1.0e-2, save_start = false, save_end = false,
    save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true)
)
@test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5

println("KYK2014DGSSPRK_3S2")
alg = KYK2014DGSSPRK_3S2()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test abs(sim.𝒪est[:final] - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test abs(sim.𝒪est[:final] - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test abs(sim.𝒪est[:final] - OrdinaryDiffEqSSPRK.alg_order(alg)) < testTol
end
# test SSP coefficient
sol = solve(
    test_problem_ssp_long, alg, dt = OrdinaryDiffEqSSPRK.ssp_coefficient(alg),
    dense = false
)
@test all(sol.u .>= 0)

@testset "VectorOfArray/StructArray compatibility" begin
    using RecursiveArrayTools, StaticArrays, StructArrays

    function rhs!(du_voa, u_voa, p, t)
        du = parent(du_voa)
        u = parent(u_voa)
        du .= u
    end

    # StructArray storage
    u = StructArray{SVector{1, Float64}}(ntuple(_ -> [1.0, 2.0], 1))
    ode = ODEProblem(rhs!, VectorOfArray(u), (0, 0.7))
    sol_SA = solve(ode, SSPRK43())

    # Vector{<:SVector} storage
    u = SVector{1, Float64}.([1.0, 2.0])
    ode = ODEProblem(rhs!, VectorOfArray(u), (0, 0.7))
    sol_SV = solve(ode, SSPRK43())

    @test sol_SA ≈ sol_SV
    @test sol_SV.stats.naccept == sol_SA.stats.naccept
end

function initialize!(integrator, cache::SSPRK22ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK22ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator

    # u1 -> stored as u
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + dt * integrator.fsalfirst
    k = f(u, p, t + dt)
    # u
    u = (uprev + u + dt * k) / 2

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK22Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK22Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, stage_limiter!, step_limiter!, thread) = cache

    # u1 -> stored as u
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + dt * fsalfirst
    stage_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    # u
    @.. broadcast = false thread = thread u = (uprev + u + dt * k) / 2
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
end

function initialize!(integrator, cache::KYKSSPRK42Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    return integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
end

@muladd function perform_step!(integrator, cache::KYKSSPRK42Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, tmp, fsalfirst, stage_limiter!, step_limiter!, thread) = cache
    (; α20, α21, α30, α32, α40, α43, β10, β21, β30, β32, β40, β43, c1, c2, c3) = cache.tab

    δ = fsalfirst
    # u1 -> stored as u
    @.. broadcast = false thread = thread u = uprev + dt * β10 * δ
    stage_limiter!(u, integrator, p, t + c1 * dt)
    f(k, u, p, t + c1 * dt)
    # u2
    @.. broadcast = false thread = thread tmp = α20 * uprev + α21 * u + dt * β21 * k
    stage_limiter!(tmp, integrator, p, t + c2 * dt)
    f(k, tmp, p, t + c2 * dt)
    # u3
    @.. broadcast = false thread = thread tmp = α30 * uprev + α32 * tmp + dt * β30 * δ +
        dt * β32 * k
    stage_limiter!(tmp, integrator, p, t + c3 * dt)
    f(k, tmp, p, t + c3 * dt)
    # u
    @.. broadcast = false thread = thread u = α40 * uprev + α43 * tmp + dt * β40 * δ +
        dt * β43 * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
end

function initialize!(integrator, cache::KYKSSPRK42ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::KYKSSPRK42ConstantCache)
    (; t, dt, uprev, u, f, p) = integrator
    (; α20, α21, α30, α32, α40, α43, β10, β21, β30, β32, β40, β43, c1, c2, c3) = cache

    #u1
    δ = integrator.fsalfirst
    u = uprev + dt * β10 * δ
    k = f(u, p, t + c1 * dt)
    #u2
    tmp = α20 * uprev + α21 * u + dt * β21 * k
    k = f(tmp, p, t + c2 * dt)
    #u3
    tmp = α30 * uprev + α32 * tmp + dt * β30 * δ + dt * β32 * k
    k = f(tmp, p, t + c3 * dt)
    #u
    u = α40 * uprev + α43 * tmp + dt * β40 * δ + dt * β43 * k

    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    integrator.k[1] = integrator.fsalfirst
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK33ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK33ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator

    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + dt * integrator.fsalfirst
    k = f(u, p, t + dt)
    # u2
    u = (3 * uprev + u + dt * k) / 4
    k = f(u, p, t + dt / 2)
    # u
    u = (uprev + 2 * u + 2 * dt * k) / 3

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK33Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK33Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, stage_limiter!, step_limiter!, thread) = cache

    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + dt * fsalfirst
    stage_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    # u2
    @.. broadcast = false thread = thread u = (3 * uprev + u + dt * k) / 4
    stage_limiter!(u, integrator, p, t + dt / 2)
    f(k, u, p, t + dt / 2)
    # u
    @.. broadcast = false thread = thread u = (uprev + 2 * u + 2 * dt * k) / 3
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
end

function initialize!(integrator, cache::SSPRK53ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK53ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; α30, α32, α40, α43, α52, α54, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache

    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    tmp = uprev + β10 * dt * integrator.fsalfirst
    k = f(tmp, p, t + c1 * dt)
    # u2 -> stored as u
    u = tmp + β21 * dt * k
    k = f(u, p, t + c2 * dt)
    # u3
    tmp = α30 * uprev + α32 * u + β32 * dt * k
    k = f(tmp, p, t + c3 * dt)
    # u4
    tmp = α40 * uprev + α43 * tmp + β43 * dt * k
    k = f(tmp, p, t + c4 * dt)
    # u
    u = α52 * u + α54 * tmp + β54 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK53Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK53Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, tmp, stage_limiter!, step_limiter!, thread) = cache
    (; α30, α32, α40, α43, α52, α54, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache.tab

    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread tmp = uprev + β10 * dt * fsalfirst
    stage_limiter!(tmp, integrator, p, t + c1 * dt)
    f(k, tmp, p, t + c1 * dt)
    # u2 -> stored as u
    @.. broadcast = false thread = thread u = tmp + β21 * dt * k
    stage_limiter!(u, integrator, p, t + c2 * dt)
    f(k, u, p, t + c2 * dt)
    # u3
    @.. broadcast = false thread = thread tmp = α30 * uprev + α32 * u + β32 * dt * k
    stage_limiter!(tmp, integrator, p, t + c3 * dt)
    f(k, tmp, p, t + c3 * dt)
    # u4
    @.. broadcast = false thread = thread tmp = α40 * uprev + α43 * tmp + β43 * dt * k
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k, tmp, p, t + c4 * dt)
    # u
    @.. broadcast = false thread = thread u = α52 * u + α54 * tmp + β54 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
end

function initialize!(integrator, cache::SSPRK53_2N1ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRK53_2N1ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    (; α40, α43, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache
    #stores in u for all intermediate stages
    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + β10 * dt * integrator.fsalfirst
    k = f(u, p, t + c1 * dt)
    # u2
    u = u + β21 * dt * k
    k = f(u, p, t + c2 * dt)
    # u3
    u = u + β32 * dt * k
    k = f(u, p, t + c3 * dt)
    # u4
    u = α40 * uprev + α43 * u + β43 * dt * k
    k = f(u, p, t + c4 * dt)
    # u
    u = u + β54 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK53_2N1Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK53_2N1Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, stage_limiter!, step_limiter!, thread) = cache
    (; α40, α43, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache.tab

    #stores in u for all intermediate stages
    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + β10 * dt * fsalfirst
    stage_limiter!(u, integrator, p, t + c1 * dt)
    f(k, u, p, t + c1 * dt)
    # u2
    @.. broadcast = false thread = thread u = u + β21 * dt * k
    stage_limiter!(u, integrator, p, t + c2 * dt)
    f(k, u, p, t + c2 * dt)
    # u3
    @.. broadcast = false thread = thread u = u + β32 * dt * k
    stage_limiter!(u, integrator, p, t + c3 * dt)
    f(k, u, p, t + c3 * dt)
    # u4
    @.. broadcast = false thread = thread u = α40 * uprev + α43 * u + β43 * dt * k
    stage_limiter!(u, integrator, p, t + c4 * dt)
    f(k, u, p, t + c4 * dt)
    # u
    @.. broadcast = false thread = thread u = u + β54 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
end

function initialize!(integrator, cache::SSPRK53_2N2ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRK53_2N2ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    (; α30, α32, α50, α54, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache
    #stores in u for all intermediate stages
    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + β10 * dt * integrator.fsalfirst
    k = f(u, p, t + c1 * dt)
    # u2 -> stored as u
    u = u + β21 * dt * k
    k = f(u, p, t + c2 * dt)
    # u3
    u = α30 * uprev + α32 * u + β32 * dt * k
    k = f(u, p, t + c3 * dt)
    # u4
    u = u + β43 * dt * k
    k = f(u, p, t + c4 * dt)
    # u
    u = α50 * uprev + α54 * u + β54 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK53_2N2Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK53_2N2Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, stage_limiter!, step_limiter!, thread) = cache
    (; α30, α32, α50, α54, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache.tab

    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + β10 * dt * fsalfirst
    stage_limiter!(u, integrator, p, t + c1 * dt)
    f(k, u, p, t + c1 * dt)
    # u2 -> stored as u
    @.. broadcast = false thread = thread u = u + β21 * dt * k
    stage_limiter!(u, integrator, p, t + c2 * dt)
    f(k, u, p, t + c2 * dt)
    # u3
    @.. broadcast = false thread = thread u = α30 * uprev + α32 * u + β32 * dt * k
    stage_limiter!(u, integrator, p, t + c3 * dt)
    f(k, u, p, t + c3 * dt)
    # u4
    @.. broadcast = false thread = thread u = u + β43 * dt * k
    stage_limiter!(u, integrator, p, t + c4 * dt)
    f(k, u, p, t + c4 * dt)
    # u
    @.. broadcast = false thread = thread u = α50 * uprev + α54 * u + β54 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
end

function initialize!(integrator, cache::SSPRK53_HConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRK53_HConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    (; α30, α32, α40, α41, α43, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache
    #stores in u for all intermediate stages
    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    tmp = uprev + β10 * dt * integrator.fsalfirst
    k = f(tmp, p, t + c1 * dt)
    # u2
    u = tmp + β21 * dt * k
    k = f(u, p, t + c2 * dt)
    # u3
    u = α30 * uprev + α32 * u + β32 * dt * k
    k = f(u, p, t + c3 * dt)
    # u4
    u = α40 * uprev + α41 * tmp + α43 * u + β43 * dt * k
    k = f(u, p, t + c4 * dt)
    # u
    u = u + β54 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK53_HCache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK53_HCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, tmp, stage_limiter!, step_limiter!, thread) = cache
    (; α30, α32, α40, α41, α43, β10, β21, β32, β43, β54, c1, c2, c3, c4) = cache.tab
    #stores in u for all intermediate stages
    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread tmp = uprev + β10 * dt * fsalfirst
    stage_limiter!(tmp, integrator, p, t + c1 * dt)
    f(k, tmp, p, t + c1 * dt)
    # u2
    @.. broadcast = false thread = thread u = tmp + β21 * dt * k
    stage_limiter!(u, integrator, p, t + c2 * dt)
    f(k, u, p, t + c2 * dt)
    # u3
    @.. broadcast = false thread = thread u = α30 * uprev + α32 * u + β32 * dt * k
    stage_limiter!(u, integrator, p, t + c3 * dt)
    f(k, u, p, t + c3 * dt)
    # u4
    @.. broadcast = false thread = thread u = α40 * uprev + α41 * tmp + α43 * u + β43 * dt * k
    stage_limiter!(u, integrator, p, t + c4 * dt)
    f(k, u, p, t + c4 * dt)
    # u
    @.. broadcast = false thread = thread u = u + β54 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
end

function initialize!(integrator, cache::SSPRK63ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK63ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; α40, α41, α43, α62, α65, β10, β21, β32, β43, β54, β65, c1, c2, c3, c4, c5) = cache

    # u1 -> stored as u
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + β10 * dt * integrator.fsalfirst
    k = f(u, p, t + c1 * dt)
    # u2
    u₂ = u + β21 * dt * k
    k = f(u₂, p, t + c2 * dt)
    # u3
    tmp = u₂ + β32 * dt * k
    k = f(tmp, p, t + c3 * dt)
    # u4
    tmp = α40 * uprev + α41 * u + α43 * tmp + β43 * dt * k
    k = f(tmp, p, t + c4 * dt)
    # u5
    tmp = tmp + β54 * dt * k
    k = f(tmp, p, t + c5 * dt)
    # u
    u = α62 * u₂ + α65 * tmp + β65 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK63Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK63Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, tmp, u₂, stage_limiter!, step_limiter!, thread) = cache
    (;
        α40, α41, α43, α62, α65, β10, β21, β32, β43,
        β54, β65, c1, c2, c3, c4, c5,
    ) = cache.tab

    # u1 -> stored as u
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + β10 * dt * fsalfirst
    stage_limiter!(u, integrator, p, t + c1 * dt)
    f(k, u, p, t + c1 * dt)
    # u2
    @.. broadcast = false thread = thread u₂ = u + β21 * dt * k
    stage_limiter!(u₂, integrator, p, t + c2 * dt)
    f(k, u₂, p, t + c2 * dt)
    # u3
    @.. broadcast = false thread = thread tmp = u₂ + β32 * dt * k
    stage_limiter!(tmp, integrator, p, t + c3 * dt)
    f(k, tmp, p, t + c3 * dt)
    # u4
    @.. broadcast = false thread = thread tmp = α40 * uprev + α41 * u + α43 * tmp + β43 * dt * k
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k, tmp, p, t + c4 * dt)
    # u5
    @.. broadcast = false thread = thread tmp = tmp + β54 * dt * k
    stage_limiter!(tmp, integrator, p, t + c5 * dt)
    f(k, tmp, p, t + c5 * dt)
    # u
    @.. broadcast = false thread = thread u = α62 * u₂ + α65 * tmp + β65 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
end

function initialize!(integrator, cache::SSPRK73ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK73ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        α40, α43, α50, α51, α54, α73, α76, β10, β21, β32,
        β43, β54, β65, β76, c1, c2, c3, c4, c5, c6,
    ) = cache

    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u₁ = uprev + β10 * dt * integrator.fsalfirst
    k = f(u₁, p, t + c1 * dt)
    # u2
    tmp = u₁ + β21 * dt * k
    k = f(tmp, p, t + c2 * dt)
    # u3 -> stored as u
    u = tmp + β32 * dt * k
    k = f(u, p, t + c3 * dt)
    # u4
    tmp = α40 * uprev + α43 * u + β43 * dt * k
    k = f(tmp, p, t + c4 * dt)
    # u5
    tmp = α50 * uprev + α51 * u₁ + α54 * tmp + β54 * dt * k
    k = f(tmp, p, t + c5 * dt)
    # u6
    tmp = tmp + β65 * dt * k
    k = f(tmp, p, t + c6 * dt)
    # u
    u = α73 * u + α76 * tmp + β76 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 7)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK73Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK73Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, tmp, u₁, stage_limiter!, step_limiter!, thread) = cache
    (;
        α40, α43, α50, α51, α54, α73, α76, β10, β21, β32, β43,
        β54, β65, β76, c1, c2, c3, c4, c5, c6,
    ) = cache.tab

    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u₁ = uprev + β10 * dt * fsalfirst
    stage_limiter!(u₁, integrator, p, t + c1 * dt)
    f(k, u₁, p, t + c1 * dt)
    # u2
    @.. broadcast = false thread = thread tmp = u₁ + β21 * dt * k
    stage_limiter!(tmp, integrator, p, t + c2 * dt)
    f(k, tmp, p, t + c2 * dt)
    # u3 -> stored as u
    @.. broadcast = false thread = thread u = tmp + β32 * dt * k
    stage_limiter!(u, integrator, p, t + c3 * dt)
    f(k, u, p, t + c3 * dt)
    # u4
    @.. broadcast = false thread = thread tmp = α40 * uprev + α43 * u + β43 * dt * k
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k, tmp, p, t + c4 * dt)
    # u5
    @.. broadcast = false thread = thread tmp = α50 * uprev + α51 * u₁ + α54 * tmp + β54 * dt * k
    stage_limiter!(tmp, integrator, p, t + c5 * dt)
    f(k, tmp, p, t + c5 * dt)
    # u6
    @.. broadcast = false thread = thread tmp = tmp + β65 * dt * k
    stage_limiter!(tmp, integrator, p, t + c6 * dt)
    f(k, tmp, p, t + c6 * dt)
    # u
    @.. broadcast = false thread = thread u = α73 * u + α76 * tmp + β76 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 7)
end

function initialize!(integrator, cache::SSPRK83ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK83ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        α50, α51, α54, α61, α65, α72, α73, α76, β10, β21, β32, β43,
        β54, β65, β76, β87, c1, c2, c3, c4, c5, c6, c7,
    ) = cache

    # u1 -> save as u
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + β10 * dt * integrator.fsalfirst
    k = f(u, p, t + c1 * dt)
    # u2
    u₂ = u + β21 * dt * k
    k = f(u₂, p, t + c2 * dt)
    # u3
    u₃ = u₂ + β32 * dt * k
    k = f(u₃, p, t + c3 * dt)
    # u4
    tmp = u₃ + β43 * dt * k
    k = f(tmp, p, t + c4 * dt)
    # u5
    tmp = α50 * uprev + α51 * u + α54 * tmp + β54 * dt * k
    k = f(tmp, p, t + c5 * dt)
    # u6
    tmp = α61 * u + α65 * tmp + β65 * dt * k
    k = f(tmp, p, t + c6 * dt)
    # u7
    tmp = α72 * u₂ + α73 * u₃ + α76 * tmp + β76 * dt * k
    k = f(tmp, p, t + c7 * dt)
    # u
    u = tmp + β87 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK83Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK83Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, tmp, u₂, u₃, stage_limiter!, step_limiter!, thread) = cache
    (;
        α50, α51, α54, α61, α65, α72, α73, α76, β10, β21, β32, β43,
        β54, β65, β76, β87, c1, c2, c3, c4, c5, c6, c7,
    ) = cache.tab

    # u1 -> save as u
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + β10 * dt * fsalfirst
    stage_limiter!(u, integrator, p, t + c1 * dt)
    f(k, u, p, t + c1 * dt)
    # u2
    @.. broadcast = false thread = thread u₂ = u + β21 * dt * k
    stage_limiter!(u₂, integrator, p, t + c2 * dt)
    f(k, u₂, p, t + c2 * dt)
    # u3
    @.. broadcast = false thread = thread u₃ = u₂ + β32 * dt * k
    stage_limiter!(u₃, integrator, p, t + c3 * dt)
    f(k, u₃, p, t + c3 * dt)
    # u4
    @.. broadcast = false thread = thread tmp = u₃ + β43 * dt * k
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k, tmp, p, t + c4 * dt)
    # u5
    @.. broadcast = false thread = thread tmp = α50 * uprev + α51 * u + α54 * tmp + β54 * dt * k
    stage_limiter!(tmp, integrator, p, t + c5 * dt)
    f(k, tmp, p, t + c5 * dt)
    # u6
    @.. broadcast = false thread = thread tmp = α61 * u + α65 * tmp + β65 * dt * k
    stage_limiter!(tmp, integrator, p, t + c6 * dt)
    f(k, tmp, p, t + c6 * dt)
    # u7
    @.. broadcast = false thread = thread tmp = α72 * u₂ + α73 * u₃ + α76 * tmp + β76 * dt * k
    stage_limiter!(tmp, integrator, p, t + c7 * dt)
    f(k, tmp, p, t + c7 * dt)
    # u
    @.. broadcast = false thread = thread u = tmp + β87 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
end

function initialize!(integrator, cache::SSPRK43ConstantCache)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK43ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; one_third_u, two_thirds_u, half_u, half_t) = cache
    dt_2 = half_t * dt

    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + dt_2 * integrator.fsalfirst
    k = f(u, p, t + dt_2)
    # u2
    u = u + dt_2 * k
    k = f(u, p, t + dt)
    u = u + dt_2 * k
    utilde = u  # Initialize for JET
    if integrator.opts.adaptive
        utilde = one_third_u * uprev + two_thirds_u * u # corresponds to bhat = (1/3, 1/3, 1/3, 0)
    end
    # u3
    u = two_thirds_u * uprev + one_third_u * u
    k = f(u, p, t + dt_2)
    # u
    u = u + dt_2 * k # corresponds to b = (1/6, 1/6, 1/6, 1/2)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    if integrator.opts.adaptive
        utilde = half_u * (utilde - u) # corresponds to bhat = (1/4, 1/4, 1/4, 1/4)
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK43Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK43Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, utilde, atmp, stage_limiter!, step_limiter!, thread) = cache
    (; one_third_u, two_thirds_u, half_u, half_t) = cache.tab
    dt_2 = half_t * dt

    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + dt_2 * fsalfirst
    stage_limiter!(u, integrator, p, t + dt_2)
    f(k, u, p, t + dt_2)
    # u2
    @.. broadcast = false thread = thread u = u + dt_2 * k
    stage_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    #
    @.. broadcast = false thread = thread u = u + dt_2 * k
    stage_limiter!(u, integrator, p, t + dt + dt_2)
    if integrator.opts.adaptive
        @.. broadcast = false utilde = one_third_u * uprev + two_thirds_u * u # corresponds to bhat = (1/3, 1/3, 1/3, 0)
    end
    # u3
    @.. broadcast = false thread = thread u = two_thirds_u * uprev + one_third_u * u
    f(k, u, p, t + dt_2)
    #
    @.. broadcast = false thread = thread u = u + dt_2 * k # corresponds to b = (1/6, 1/6, 1/6, 1/2)
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)

    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = half_u * (utilde - u) # corresponds to bhat = (1/4, 1/4, 1/4, 1/4)
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
end

function initialize!(integrator, cache::SSPRK432ConstantCache)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRK432ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    dt_2 = dt / 2

    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + dt_2 * integrator.fsalfirst
    k = f(u, p, t + dt_2)
    # u2
    u = u + dt_2 * k
    k = f(u, p, t + dt)
    u = u + dt_2 * k
    utilde = u  # Initialize for JET
    if integrator.opts.adaptive
        utilde = (uprev + 2 * u) / 3
    end
    # u3
    u = (2 * uprev + u) / 3
    k = f(u, p, t + dt_2)
    # u
    u = u + dt_2 * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    if integrator.opts.adaptive
        utilde = utilde - u
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK432Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK432Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, utilde, atmp, stage_limiter!, step_limiter!, thread) = cache
    dt_2 = dt / 2

    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + dt_2 * fsalfirst
    stage_limiter!(u, integrator, p, t + dt_2)
    f(k, u, p, t + dt_2)
    # u2
    @.. broadcast = false thread = thread u = u + dt_2 * k
    stage_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    #
    @.. broadcast = false thread = thread u = u + dt_2 * k
    stage_limiter!(u, integrator, p, t + dt + dt_2)
    if integrator.opts.adaptive
        @.. broadcast = false utilde = (uprev + 2 * u) / 3
    end
    # u3
    @.. broadcast = false thread = thread u = (2 * uprev + u) / 3
    f(k, u, p, t + dt_2)
    #
    @.. broadcast = false thread = thread u = u + dt_2 * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)

    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = utilde - u
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
end

function initialize!(integrator, cache::SSPRKMSVS32ConstantCache)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRKMSVS32ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    (; u_1, u_2, dts, dtf, μ, v_n) = cache

    if integrator.iter == 1
        cache.dts[1] = dt
        cache.dts[2] = dt
        cache.dtf[1] = dt
    end
    accpt = true
    dt = dts[1]

    if cache.step < 3 #starting Procedure
        k = f(u, p, t + dt)
        u = uprev + dt * k
        k = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
        u = (uprev + u + dt * k) / 2
        if cache.step == 1
            u_2 = uprev
        else
            u_1 = uprev
        end
        if integrator.opts.adaptive
            v_n = dt / dts[2] * 0.5
            cache.dtf[2] = dtf[1]
            cache.dtf[1] = dt / v_n * 0.5
            if v_n > 0.5
                cache.step -= 1
                accpt = false
            end
            cache.dts[3] = dts[2]
            cache.dts[2] = dt
            dt = 0.9 * dtf[1]
            μ = min(dtf[1], dtf[2])
        end
    else
        if integrator.opts.adaptive
            Ω = (dts[2] + dts[3]) / dt
        else
            Ω = 2
        end
        u = (Ω * Ω - 1) / (Ω * Ω) * (uprev + Ω / (Ω - 1) * dt * integrator.fsalfirst) +
            1 / (Ω * Ω) * u_2
        u_2 = u_1
        u_1 = uprev
        if integrator.opts.adaptive
            v_n = (dts[2] + dts[3] - dt) / (dts[2] + dts[3]) * 0.5
            dt = (dts[2] + dts[3]) / (dts[2] + dts[3] + μ) * μ
            cache.dtf[2] = dtf[1]
            dtf[1] = dt / v_n * 0.5
            cache.dts[3] = dts[2]
            cache.dts[2] = dt
            μ = min(dtf[1], dtf[2])
        end
    end
    if accpt == true
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.u = u
    else
        integrator.fsallast = f(uprev, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.u = uprev
    end
    cache.dts[1] = dt
    cache.step += 1
    cache.u_1 = u_1
    cache.u_2 = u_2
    cache.μ = μ
end

function initialize!(integrator, cache::SSPRKMSVS32Cache)
    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.fsalfirst = cache.fsalfirst  # done by pointers, no copying
    integrator.fsallast = cache.k
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t)
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::SSPRKMSVS32Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, u_1, u_2, stage_limiter!, step_limiter!, thread) = cache

    if cache.step < 3
        @.. broadcast = false thread = thread u = uprev + dt * fsalfirst
        stage_limiter!(u, integrator, p, t + dt)
        f(k, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast = false thread = thread u = (uprev + u + dt * k) / 2
        stage_limiter!(u, integrator, p, t + dt)
        step_limiter!(u, integrator, p, t + dt)

        if cache.step == 1
            cache.u_2 .= uprev
        else
            cache.u_1 .= uprev
        end
    else
        Ω = 2
        @.. broadcast = false thread = thread u = ((Ω * Ω - 1) / (Ω * Ω)) *
            (uprev + (Ω / (Ω - 1)) * dt * fsalfirst) +
            (1 / (Ω * Ω)) * cache.u_2
        cache.u_2 .= u_1
        cache.u_1 .= uprev
        stage_limiter!(u, integrator, p, t + dt)
        step_limiter!(u, integrator, p, t + dt)
    end
    cache.step += 1
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    f(k, u, p, t + dt)
end

function initialize!(integrator, cache::SSPRKMSVS43ConstantCache)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRKMSVS43ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    (; u_1, u_2, u_3, k1, k2, k3) = cache

    if cache.step < 4
        u = uprev + dt * integrator.fsalfirst
        k = f(u, p, t + dt)
        u = (uprev + u + dt * k) / 2
        if cache.step == 1
            u_3 = uprev
            cache.k3 = f(u_3, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        if cache.step == 2
            u_2 = uprev
            cache.k2 = f(u_2, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        if cache.step == 3
            u_1 = uprev
            cache.k1 = f(u_1, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        # u
    else
        u = (16 / 27) * (uprev + 3 * dt * integrator.fsalfirst) +
            (11 / 27) * (u_3 + (12 / 11) * dt * k3)
        cache.k3 = k2
        cache.k2 = k1
        cache.k1 = integrator.fsalfirst
        u_3 = u_2
        u_2 = u_1
        u_1 = uprev
    end
    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.u = u
    cache.step += 1
    cache.u_1 = u_1
    cache.u_2 = u_2
    cache.u_3 = u_3
end

function initialize!(integrator, cache::SSPRKMSVS43Cache)
    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.fsalfirst = cache.fsalfirst  # done by pointers, no copying
    integrator.fsallast = cache.k
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::SSPRKMSVS43Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        k, fsalfirst, u_1, u_2, u_3, stage_limiter!,
        step_limiter!, thread, k1, k2, k3,
    ) = cache

    if cache.step < 4
        @.. broadcast = false thread = thread u = uprev + dt * fsalfirst
        stage_limiter!(u, integrator, p, t + dt)
        f(k, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast = false thread = thread u = (uprev + u + dt * k) / 2
        stage_limiter!(u, integrator, p, t + dt)
        step_limiter!(u, integrator, p, t + dt)
        if cache.step == 1
            cache.u_3 .= uprev
            f(k3, u_3, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        if cache.step == 2
            cache.u_2 .= uprev
            f(k2, u_2, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        if cache.step == 3
            cache.u_1 .= uprev
            f(k1, u_1, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        # u
    else
        @.. broadcast = false thread = thread u = (16 / 27) * (uprev + 3 * dt * fsalfirst) +
            (11 / 27) * (u_3 + (12 / 11) * dt * k3)
        stage_limiter!(u, integrator, p, t + dt)
        step_limiter!(u, integrator, p, t + dt)
        cache.k3 .= k2
        cache.k2 .= k1
        cache.k1 .= fsalfirst
        cache.u_3 .= u_2
        cache.u_2 .= u_1
        cache.u_1 .= uprev
    end
    cache.step += 1
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    f(k, u, p, t + dt)
end

function initialize!(integrator, cache::SSPRK932ConstantCache)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRK932ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    dt_6 = dt / 6
    dt_3 = dt / 3
    dt_2 = dt / 2

    # u1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u = uprev + dt_6 * integrator.fsalfirst
    k = f(u, p, t + dt_6)
    # u2
    u = u + dt_6 * k
    k = f(u, p, t + dt_3)
    # u3
    u = u + dt_6 * k
    k = f(u, p, t + dt_2)
    # u4
    u = u + dt_6 * k
    k = f(u, p, t + 2 * dt_3)
    # u5
    u = u + dt_6 * k
    k = f(u, p, t + 5 * dt_6)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    # u6
    u = u + dt_6 * k
    utilde = u  # Initialize for JET
    if integrator.opts.adaptive
        k = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        utilde = (uprev + 6 * u + 6 * dt * k) / 7
    end
    # u6*
    u = (3 * uprev + dt_2 * integrator.fsalfirst + 2 * u) / 5
    k = f(u, p, t + dt_2)
    # u7*
    u = u + dt_6 * k
    k = f(u, p, t + 2 * dt_3)
    # u8*
    u = u + dt_6 * k
    k = f(u, p, t + 5 * dt_6)
    # u
    u = u + dt_6 * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    if integrator.opts.adaptive
        utilde = utilde - u
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK932Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK932Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, utilde, atmp, stage_limiter!, step_limiter!, thread) = cache
    dt_6 = dt / 6
    dt_3 = dt / 3
    dt_2 = dt / 2

    # u1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = uprev + dt_6 * fsalfirst
    stage_limiter!(u, integrator, p, t + dt_6)
    f(k, u, p, t + dt_6)
    # u2
    @.. broadcast = false thread = thread u = u + dt_6 * k
    stage_limiter!(u, integrator, p, t + dt_3)
    f(k, u, p, t + dt_3)
    # u3
    @.. broadcast = false thread = thread u = u + dt_6 * k
    stage_limiter!(u, integrator, p, t + dt_2)
    f(k, u, p, t + dt_2)
    # u4
    @.. broadcast = false thread = thread u = u + dt_6 * k
    stage_limiter!(u, integrator, p, t + 2 * dt_3)
    f(k, u, p, t + 2 * dt_3)
    # u5
    @.. broadcast = false thread = thread u = u + dt_6 * k
    stage_limiter!(u, integrator, p, t + 5 * dt_6)
    f(k, u, p, t + 5 * dt_6)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    # u6
    @.. broadcast = false thread = thread u = u + dt_6 * k
    if integrator.opts.adaptive
        stage_limiter!(u, integrator, p, t + dt)
        f(k, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast = false thread = thread utilde = (uprev + 6 * u + 6 * dt * k) / 7
    end
    # u6*
    @.. broadcast = false thread = thread u = (3 * uprev + dt_2 * integrator.fsalfirst + 2 * u) /
        5
    stage_limiter!(u, integrator, p, t + dt_6)
    f(k, u, p, t + dt_2)
    # u7*
    @.. broadcast = false thread = thread u = u + dt_6 * k
    stage_limiter!(u, integrator, p, t + 2 * dt_3)
    f(k, u, p, t + 2 * dt_3)
    # u8*
    @.. broadcast = false thread = thread u = u + dt_6 * k
    stage_limiter!(u, integrator, p, t + 5 * dt_6)
    f(k, u, p, t + 5 * dt_6)
    # u9*
    @.. broadcast = false thread = thread u = u + dt_6 * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)

    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = utilde - u
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

function initialize!(integrator, cache::SSPRK54ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK54ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        β10, α20, α21, β21, α30, α32, β32, α40, α43, β43,
        α52, α53, β53, α54, β54, c1, c2, c3, c4,
    ) = cache

    # u₁
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u₂ = uprev + β10 * dt * integrator.fsalfirst
    k = f(u₂, p, t + c1 * dt)
    # u₂
    u₂ = α20 * uprev + α21 * u₂ + β21 * dt * k
    k = f(u₂, p, t + c2 * dt)
    # u₃
    u₃ = α30 * uprev + α32 * u₂ + β32 * dt * k
    k₃ = f(u₃, p, t + c3 * dt)
    # u₄ -> stored as tmp
    tmp = α40 * uprev + α43 * u₃ + β43 * dt * k₃
    k = f(tmp, p, t + c4 * dt)
    # u
    u = α52 * u₂ + α53 * u₃ + β53 * dt * k₃ + α54 * tmp + β54 * dt * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK54Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK54Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, k₃, u₂, u₃, tmp, stage_limiter!, step_limiter!, thread) = cache
    (;
        β10, α20, α21, β21, α30, α32, β32, α40, α43, β43,
        α52, α53, β53, α54, β54, c1, c2, c3, c4,
    ) = cache.tab

    # u₁
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u₂ = uprev + β10 * dt * fsalfirst
    stage_limiter!(u₂, integrator, p, t + c1 * dt)
    f(k, u₂, p, t + c1 * dt)
    # u₂
    @.. broadcast = false thread = thread u₂ = α20 * uprev + α21 * u₂ + β21 * dt * k
    stage_limiter!(u₂, integrator, p, t + c2 * dt)
    f(k, u₂, p, t + c2 * dt)
    # u₃
    @.. broadcast = false thread = thread u₃ = α30 * uprev + α32 * u₂ + β32 * dt * k
    stage_limiter!(u₃, integrator, p, t + c3 * dt)
    f(k₃, u₃, p, t + c3 * dt)
    # u₄ -> stored as tmp
    @.. broadcast = false thread = thread tmp = α40 * uprev + α43 * u₃ + β43 * dt * k₃
    stage_limiter!(tmp, integrator, p, t + c4 * dt)
    f(k, tmp, p, t + c4 * dt)
    # u
    @.. broadcast = false thread = thread u = α52 * u₂ + α53 * u₃ + β53 * dt * k₃ + α54 * tmp +
        β54 * dt * k
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
end

function initialize!(integrator, cache::SSPRK104ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(
        integrator, cache::SSPRK104ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    dt_6 = dt / 6
    dt_3 = dt / 3
    dt_2 = dt / 2

    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    tmp = uprev + dt_6 * integrator.fsalfirst # u₁
    k = f(tmp, p, t + dt_6)
    tmp = tmp + dt_6 * k # u₂
    k = f(tmp, p, t + dt_3)
    tmp = tmp + dt_6 * k # u₃
    k = f(tmp, p, t + dt_2)
    u = tmp + dt_6 * k # u₄
    k₄ = f(u, p, t + 2 * dt_3)
    tmp = (3 * uprev + 2 * u + 2 * dt_6 * k₄) / 5 # u₅
    k = f(tmp, p, t + dt_3)
    tmp = tmp + dt_6 * k # u₆
    k = f(tmp, p, t + dt_2)
    tmp = tmp + dt_6 * k # u₇
    k = f(tmp, p, t + 2 * dt_3)
    tmp = tmp + dt_6 * k # u₈
    k = f(tmp, p, t + 5 * dt_6)
    tmp = tmp + dt_6 * k # u₉
    k = f(tmp, p, t + dt)
    u = (uprev + 9 * (u + dt_6 * k₄) + 15 * (tmp + dt_6 * k)) / 25

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
    integrator.u = u
end

function initialize!(integrator, cache::SSPRK104Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::SSPRK104Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, k₄, tmp, stage_limiter!, step_limiter!, thread) = cache
    dt_6 = dt / 6
    dt_3 = dt / 3
    dt_2 = dt / 2

    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread tmp = uprev + dt_6 * fsalfirst
    stage_limiter!(tmp, integrator, p, t + dt_6)
    f(k, tmp, p, t + dt_6)
    @.. broadcast = false tmp = tmp + dt_6 * k
    stage_limiter!(tmp, integrator, p, t + dt_3)
    f(k, tmp, p, t + dt_3)
    @.. broadcast = false thread = thread tmp = tmp + dt_6 * k
    stage_limiter!(tmp, integrator, p, t + dt_2)
    f(k, tmp, p, t + dt_2)
    @.. broadcast = false thread = thread u = tmp + dt_6 * k
    stage_limiter!(u, integrator, p, t + 2 * dt_3)
    f(k₄, u, p, t + 2 * dt_3)
    @.. broadcast = false thread = thread tmp = (3 * uprev + 2 * u + 2 * dt_6 * k₄) / 5
    stage_limiter!(tmp, integrator, p, t + dt_3)
    f(k, tmp, p, t + dt_3)
    @.. broadcast = false thread = thread tmp = tmp + dt_6 * k
    stage_limiter!(tmp, integrator, p, t + dt_2)
    f(k, tmp, p, t + dt_2)
    @.. broadcast = false thread = thread tmp = tmp + dt_6 * k
    stage_limiter!(tmp, integrator, p, t + 2 * dt_3)
    f(k, tmp, p, t + 2 * dt_3)
    @.. broadcast = false thread = thread tmp = tmp + dt_6 * k
    stage_limiter!(tmp, integrator, p, t + 5 * dt_6)
    f(k, tmp, p, t + 5 * dt_6)
    @.. broadcast = false thread = thread tmp = tmp + dt_6 * k
    stage_limiter!(tmp, integrator, p, t + dt)
    f(k, tmp, p, t + dt)
    @.. broadcast = false thread = thread u = (
        uprev + 9 * (u + dt_6 * k₄) +
            15 * (tmp + dt_6 * k)
    ) / 25
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
end

function initialize!(integrator, cache::KYK2014DGSSPRK_3S2_ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    return nothing
end

@muladd function perform_step!(
        integrator, cache::KYK2014DGSSPRK_3S2_ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    (; α_10, α_20, α_21, α_30, α_32, β_10, β_21, β_30, β_32, c_1, c_2) = cache
    u_1 = α_10 * uprev + dt * β_10 * integrator.fsalfirst
    u_2 = (
        α_20 * uprev +
            α_21 * u_1 + dt * β_21 * f(u_1, p, t + c_1 * dt)
    )
    integrator.u = (
        α_30 * uprev + dt * β_30 * integrator.fsalfirst +
            α_32 * u_2 + dt * β_32 * f(u_2, p, t + c_2 * dt)
    )
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = f(integrator.u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    integrator.fsallast = integrator.k[2]
    return nothing
end

function initialize!(integrator, cache::KYK2014DGSSPRK_3S2_Cache)
    (; k, fsalfirst) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return nothing
end

@muladd function perform_step!(
        integrator, cache::KYK2014DGSSPRK_3S2_Cache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, u_1, u_2, kk_1, kk_2, stage_limiter!, step_limiter!, thread) = cache
    (; α_10, α_20, α_21, α_30, α_32, β_10, β_21, β_30, β_32, c_1, c_2) = cache.tab

    @.. broadcast = false thread = thread u_1 = α_10 * uprev + dt * β_10 * integrator.fsalfirst
    stage_limiter!(u_1, integrator, p, t + c_1 * dt)
    f(kk_1, u_1, p, t + c_1 * dt)
    @.. broadcast = false thread = thread u_2 = (
        α_20 * uprev +
            α_21 * u_1 + dt * β_21 * kk_1
    )
    stage_limiter!(u_2, integrator, p, t + c_2 * dt)
    f(kk_2, u_2, p, t + c_2 * dt)
    @.. broadcast = false thread = thread u = (
        α_30 * uprev +
            dt * β_30 * integrator.fsalfirst +
            α_32 * u_2 + dt * β_32 * kk_2
    )
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
    f(integrator.k[2], u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    return nothing
end

# pRRK methods: Parametric Relaxation Runge-Kutta (Liu et al. 2023)
# The pRRK modification adds a stabilization term κ(u - u) to the ODE.
# This modifies the Shu-Osher coefficients:
#   ψ₀ = 1, ψᵢ = Σⱼ ψⱼ(αᵢⱼ + z·βᵢⱼ) where z = κ·Δt
#   α̂ᵢⱼ = (ψⱼ/ψᵢ)(αᵢⱼ + z·βᵢⱼ)
#   β̂ᵢⱼ = (ψⱼ/ψᵢ)·βᵢⱼ
# The effective time step becomes Δt̂ = ĉₛ·Δt where ĉₛ is the last abscissa.

# Helper: compute modified coefficients for pRRK22
# Base: u₁ = u₀ + Δt·f(u₀),  u₂ = ½u₀ + ½u₁ + ½Δt·f(u₁)
@inline function _prrk22_coeffs(z, α10, β10, α20, α21, β21)
    # ψ₀ = 1
    # ψ₁ = α₁₀ + z·β₁₀
    ψ1 = α10 + z * β10
    # ψ₂ = (α₂₀ + 0) + ψ₁(α₂₁ + z·β₂₁)  (β₂₀=0)
    ψ2 = α20 + ψ1 * (α21 + z * β21)

    # Modified coefficients
    α̂10 = (α10 + z * β10) / ψ1
    β̂10 = β10 / ψ1

    α̂20 = α20 / ψ2
    α̂21 = ψ1 * (α21 + z * β21) / ψ2
    β̂21 = ψ1 * β21 / ψ2

    # Modified abscissae: ĉ₀ = 0, ĉ₁ = α̂₁₀·0 + β̂₁₀ = β̂₁₀
    ĉ1 = β̂10
    # ĉ₂ = α̂₂₀·0 + α̂₂₁·ĉ₁ + β̂₂₁
    ĉ2 = α̂21 * ĉ1 + β̂21

    return α̂10, β̂10, α̂20, α̂21, β̂21, ĉ1, ĉ2
end

function initialize!(integrator, cache::pRRK22ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::pRRK22ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; κ, α10, β10, α20, α21, β21) = cache

    z = κ * dt
    α̂10, β̂10, α̂20, α̂21, β̂21, ĉ1, ĉ2 = _prrk22_coeffs(z, α10, β10, α20, α21, β21)

    # Rescaled time step
    dt_hat = ĉ2 * dt

    # Stage 1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u1 = α̂10 * uprev + β̂10 * dt_hat * integrator.fsalfirst
    k = f(u1, p, t + ĉ1 * dt_hat)

    # Stage 2 (final)
    u = α̂20 * uprev + α̂21 * u1 + β̂21 * dt_hat * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    integrator.u = u
end

function initialize!(integrator, cache::pRRK22Cache)
    (; k, fsalfirst) = cache
    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::pRRK22Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, stage_limiter!, step_limiter!, thread) = cache
    (; κ, α10, β10, α20, α21, β21) = cache.tab

    z = κ * dt
    α̂10, β̂10, α̂20, α̂21, β̂21, ĉ1, ĉ2 = _prrk22_coeffs(z, α10, β10, α20, α21, β21)

    dt_hat = ĉ2 * dt

    # Stage 1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = α̂10 * uprev + β̂10 * dt_hat * fsalfirst
    stage_limiter!(u, integrator, p, t + ĉ1 * dt_hat)
    f(k, u, p, t + ĉ1 * dt_hat)

    # Stage 2 (final)
    @.. broadcast = false thread = thread u = α̂20 * uprev + α̂21 * u + β̂21 * dt_hat * k
    stage_limiter!(u, integrator, p, t + dt_hat)
    step_limiter!(u, integrator, p, t + dt_hat)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
end

# Helper: compute modified coefficients for pRRK33
@inline function _prrk33_coeffs(z, α10, β10, α20, α21, β21, α30, α32, β32)
    # ψ₁ = α₁₀ + z·β₁₀
    ψ1 = α10 + z * β10
    # ψ₂ = α₂₀ + ψ₁(α₂₁ + z·β₂₁)
    ψ2 = α20 + ψ1 * (α21 + z * β21)
    # ψ₃ = α₃₀ + ψ₂(α₃₂ + z·β₃₂)  (α₃₁=0, β₃₀=β₃₁=0)
    ψ3 = α30 + ψ2 * (α32 + z * β32)

    α̂10 = (α10 + z * β10) / ψ1
    β̂10 = β10 / ψ1

    α̂20 = α20 / ψ2
    α̂21 = ψ1 * (α21 + z * β21) / ψ2
    β̂21 = ψ1 * β21 / ψ2

    α̂30 = α30 / ψ3
    α̂32 = ψ2 * (α32 + z * β32) / ψ3
    β̂32 = ψ2 * β32 / ψ3

    # Modified abscissae
    ĉ1 = β̂10
    ĉ2 = α̂21 * ĉ1 + β̂21
    ĉ3 = α̂32 * ĉ2 + β̂32

    return α̂10, β̂10, α̂20, α̂21, β̂21, α̂30, α̂32, β̂32, ĉ1, ĉ2, ĉ3
end

function initialize!(integrator, cache::pRRK33ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::pRRK33ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; κ, α10, β10, α20, α21, β21, α30, α32, β32) = cache

    z = κ * dt
    α̂10, β̂10, α̂20, α̂21, β̂21, α̂30, α̂32, β̂32, ĉ1, ĉ2, ĉ3 = _prrk33_coeffs(
        z, α10, β10, α20, α21, β21, α30, α32, β32
    )

    dt_hat = ĉ3 * dt

    # Stage 1
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u1 = α̂10 * uprev + β̂10 * dt_hat * integrator.fsalfirst
    k = f(u1, p, t + ĉ1 * dt_hat)

    # Stage 2
    u2 = α̂20 * uprev + α̂21 * u1 + β̂21 * dt_hat * k
    k = f(u2, p, t + ĉ2 * dt_hat)

    # Stage 3 (final)
    u = α̂30 * uprev + α̂32 * u2 + β̂32 * dt_hat * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    integrator.u = u
end

function initialize!(integrator, cache::pRRK33Cache)
    (; k, fsalfirst) = cache
    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::pRRK33Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, stage_limiter!, step_limiter!, thread) = cache
    (; κ, α10, β10, α20, α21, β21, α30, α32, β32) = cache.tab

    z = κ * dt
    α̂10, β̂10, α̂20, α̂21, β̂21, α̂30, α̂32, β̂32, ĉ1, ĉ2, ĉ3 = _prrk33_coeffs(
        z, α10, β10, α20, α21, β21, α30, α32, β32
    )

    dt_hat = ĉ3 * dt

    # Stage 1
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u = α̂10 * uprev + β̂10 * dt_hat * fsalfirst
    stage_limiter!(u, integrator, p, t + ĉ1 * dt_hat)
    f(k, u, p, t + ĉ1 * dt_hat)

    # Stage 2 (reuse u as temporary)
    @.. broadcast = false thread = thread u = α̂20 * uprev + α̂21 * u + β̂21 * dt_hat * k
    stage_limiter!(u, integrator, p, t + ĉ2 * dt_hat)
    f(k, u, p, t + ĉ2 * dt_hat)

    # Stage 3 (final)
    @.. broadcast = false thread = thread u = α̂30 * uprev + α̂32 * u + β̂32 * dt_hat * k
    stage_limiter!(u, integrator, p, t + dt_hat)
    step_limiter!(u, integrator, p, t + dt_hat)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
end

# Helper: compute modified coefficients for pRRK54
@inline function _prrk54_coeffs(
        z, β10, α20, α21, β21, α30, α32, β32,
        α40, α43, β43, α52, α53, β53, α54, β54
    )
    # Stage indexing: 0=u₀, 1=u₁, 2=u₂, 3=u₃, 4=u₄, 5=u₅(=uₙ₊₁)
    # Shu-Osher for SSPRK54 (only nonzero entries):
    # u₁: α₁₀=1 (implicit), β₁₀
    # u₂: α₂₀, α₂₁, β₂₁
    # u₃: α₃₀, α₃₂, β₃₂
    # u₄: α₄₀, α₄₃, β₄₃
    # u₅: α₅₂, α₅₃, β₅₃, α₅₄, β₅₄
    α10 = one(z)

    ψ1 = α10 + z * β10
    ψ2 = α20 + ψ1 * (α21 + z * β21)
    ψ3 = α30 + ψ2 * (α32 + z * β32)
    ψ4 = α40 + ψ3 * (α43 + z * β43)
    ψ5 = ψ2 * (α52 + z * zero(z)) + ψ3 * (α53 + z * β53) + ψ4 * (α54 + z * β54)

    # Modified α̂, β̂
    α̂10 = (α10 + z * β10) / ψ1
    β̂10 = β10 / ψ1

    α̂20 = α20 / ψ2
    α̂21 = ψ1 * (α21 + z * β21) / ψ2
    β̂21 = ψ1 * β21 / ψ2

    α̂30 = α30 / ψ3
    α̂32 = ψ2 * (α32 + z * β32) / ψ3
    β̂32 = ψ2 * β32 / ψ3

    α̂40 = α40 / ψ4
    α̂43 = ψ3 * (α43 + z * β43) / ψ4
    β̂43 = ψ3 * β43 / ψ4

    α̂52 = ψ2 * α52 / ψ5  # β₅₂=0
    α̂53 = ψ3 * (α53 + z * β53) / ψ5
    β̂53 = ψ3 * β53 / ψ5
    α̂54 = ψ4 * (α54 + z * β54) / ψ5
    β̂54 = ψ4 * β54 / ψ5

    # Modified abscissae
    ĉ1 = β̂10
    ĉ2 = α̂21 * ĉ1 + β̂21
    ĉ3 = α̂32 * ĉ2 + β̂32
    ĉ4 = α̂43 * ĉ3 + β̂43
    ĉ5 = α̂52 * ĉ2 + α̂53 * ĉ3 + β̂53 + α̂54 * ĉ4 + β̂54

    return (
        α̂10, β̂10, α̂20, α̂21, β̂21, α̂30, α̂32, β̂32,
        α̂40, α̂43, β̂43, α̂52, α̂53, β̂53, α̂54, β̂54,
        ĉ1, ĉ2, ĉ3, ĉ4, ĉ5,
    )
end

function initialize!(integrator, cache::pRRK54ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsallast = zero(integrator.fsalfirst)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::pRRK54ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        κ, β10, α20, α21, β21, α30, α32, β32,
        α40, α43, β43, α52, α53, β53, α54, β54,
    ) = cache

    z = κ * dt
    (
        α̂10, β̂10, α̂20, α̂21, β̂21, α̂30, α̂32, β̂32,
        α̂40, α̂43, β̂43, α̂52, α̂53, β̂53, α̂54, β̂54,
        ĉ1, ĉ2, ĉ3, ĉ4, ĉ5,
    ) = _prrk54_coeffs(
        z, β10, α20, α21, β21, α30, α32, β32,
        α40, α43, β43, α52, α53, β53, α54, β54
    )

    dt_hat = ĉ5 * dt

    # u₁
    integrator.fsalfirst = f(uprev, p, t)
    integrator.k[1] = integrator.fsalfirst
    u₂ = α̂10 * uprev + β̂10 * dt_hat * integrator.fsalfirst
    k = f(u₂, p, t + ĉ1 * dt_hat)
    # u₂
    u₂ = α̂20 * uprev + α̂21 * u₂ + β̂21 * dt_hat * k
    k = f(u₂, p, t + ĉ2 * dt_hat)
    # u₃
    u₃ = α̂30 * uprev + α̂32 * u₂ + β̂32 * dt_hat * k
    k₃ = f(u₃, p, t + ĉ3 * dt_hat)
    # u₄
    tmp = α̂40 * uprev + α̂43 * u₃ + β̂43 * dt_hat * k₃
    k = f(tmp, p, t + ĉ4 * dt_hat)
    # u₅ (final)
    u = α̂52 * u₂ + α̂53 * u₃ + β̂53 * dt_hat * k₃ + α̂54 * tmp + β̂54 * dt_hat * k

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.u = u
end

function initialize!(integrator, cache::pRRK54Cache)
    (; k, fsalfirst) = cache
    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    return integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::pRRK54Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k, fsalfirst, k₃, u₂, u₃, tmp, stage_limiter!, step_limiter!, thread) = cache
    (;
        κ, β10, α20, α21, β21, α30, α32, β32,
        α40, α43, β43, α52, α53, β53, α54, β54,
    ) = cache.tab

    z = κ * dt
    (
        α̂10, β̂10, α̂20, α̂21, β̂21, α̂30, α̂32, β̂32,
        α̂40, α̂43, β̂43, α̂52, α̂53, β̂53, α̂54, β̂54,
        ĉ1, ĉ2, ĉ3, ĉ4, ĉ5,
    ) = _prrk54_coeffs(
        z, β10, α20, α21, β21, α30, α32, β32,
        α40, α43, β43, α52, α53, β53, α54, β54
    )

    dt_hat = ĉ5 * dt

    # u₁
    f(fsalfirst, uprev, p, t)
    @.. broadcast = false thread = thread u₂ = α̂10 * uprev + β̂10 * dt_hat * fsalfirst
    stage_limiter!(u₂, integrator, p, t + ĉ1 * dt_hat)
    f(k, u₂, p, t + ĉ1 * dt_hat)
    # u₂
    @.. broadcast = false thread = thread u₂ = α̂20 * uprev + α̂21 * u₂ + β̂21 * dt_hat * k
    stage_limiter!(u₂, integrator, p, t + ĉ2 * dt_hat)
    f(k, u₂, p, t + ĉ2 * dt_hat)
    # u₃
    @.. broadcast = false thread = thread u₃ = α̂30 * uprev + α̂32 * u₂ + β̂32 * dt_hat * k
    stage_limiter!(u₃, integrator, p, t + ĉ3 * dt_hat)
    f(k₃, u₃, p, t + ĉ3 * dt_hat)
    # u₄ -> stored as tmp
    @.. broadcast = false thread = thread tmp = α̂40 * uprev + α̂43 * u₃ + β̂43 * dt_hat * k₃
    stage_limiter!(tmp, integrator, p, t + ĉ4 * dt_hat)
    f(k, tmp, p, t + ĉ4 * dt_hat)
    # u₅ (final)
    @.. broadcast = false thread = thread u = α̂52 * u₂ + α̂53 * u₃ + β̂53 * dt_hat * k₃ + α̂54 * tmp +
        β̂54 * dt_hat * k
    stage_limiter!(u, integrator, p, t + dt_hat)
    step_limiter!(u, integrator, p, t + dt_hat)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
end

isfsal(alg::SSPRK53_2N1) = false
isfsal(alg::SSPRK53_2N2) = false
isfsal(alg::SSPRK22) = false
isfsal(alg::SSPRK33) = false
isfsal(alg::SSPRK53) = false
isfsal(alg::SSPRK53_H) = false
isfsal(alg::SSPRK63) = false
isfsal(alg::SSPRK73) = false
isfsal(alg::SSPRK83) = false
isfsal(alg::SSPRK43) = false
isfsal(alg::SSPRK432) = false
isfsal(alg::SSPRK932) = false
isfsal(alg::SSPRK54) = false
isfsal(alg::SSPRK104) = false

alg_order(alg::KYK2014DGSSPRK_3S2) = 2
alg_order(alg::KYKSSPRK42) = 2
alg_order(alg::SSPRKMSVS32) = 2
alg_order(alg::SSPRK33) = 3
alg_order(alg::SSPRK53_2N1) = 3
alg_order(alg::SSPRK53_2N2) = 3
alg_order(alg::SSPRK22) = 2
alg_order(alg::SSPRK53) = 3
alg_order(alg::SSPRK53_H) = 3
alg_order(alg::SSPRK63) = 3
alg_order(alg::SSPRK73) = 3
alg_order(alg::SSPRK83) = 3
alg_order(alg::SSPRK43) = 3
alg_order(alg::SSPRK432) = 3
alg_order(alg::SSPRKMSVS43) = 3
alg_order(alg::SSPRK932) = 3
alg_order(alg::SSPRK54) = 4
alg_order(alg::SSPRK104) = 4

ssp_coefficient(alg::SSPRK53_2N1) = 2.18
ssp_coefficient(alg::SSPRK53_2N2) = 2.148
ssp_coefficient(alg::SSPRK53) = 2.65
ssp_coefficient(alg::SSPRK53_H) = 2.65
ssp_coefficient(alg::SSPRK63) = 3.518
ssp_coefficient(alg::SSPRK73) = 4.2879
ssp_coefficient(alg::SSPRK83) = 5.107
ssp_coefficient(alg::SSPRK43) = 2
ssp_coefficient(alg::SSPRK432) = 2
ssp_coefficient(alg::SSPRK932) = 6
ssp_coefficient(alg::SSPRK54) = 1.508
ssp_coefficient(alg::SSPRK104) = 6
ssp_coefficient(alg::SSPRK33) = 1
ssp_coefficient(alg::SSPRK22) = 1
ssp_coefficient(alg::SSPRKMSVS32) = 0.5
ssp_coefficient(alg::SSPRKMSVS43) = 0.33
ssp_coefficient(alg::KYKSSPRK42) = 2.459
ssp_coefficient(alg::KYK2014DGSSPRK_3S2) = 0.8417

isfsal(alg::pRRK22) = false
isfsal(alg::pRRK33) = false
isfsal(alg::pRRK54) = false

alg_order(alg::pRRK22) = 2
alg_order(alg::pRRK33) = 3
alg_order(alg::pRRK54) = 4

ssp_coefficient(alg::pRRK22) = 1
ssp_coefficient(alg::pRRK33) = 1
ssp_coefficient(alg::pRRK54) = 1.508

const NEGZERO = Float16(-0.0f0)

@def ssprkpre0 begin
    c00 = @evalpoly(Θ, 1, NEGZERO, -1)
    c10 = Θ^2
    b10dt = Θ * @evalpoly(Θ, 1, -1) * dt
end

@def ssprkpre1 begin
    b10diff = @evalpoly(Θ, 1, -2)
    c10diffinvdt = 2Θ * inv(dt) # = -c00diff * inv(dt)
end

@def ssprkpre2 begin
    invdt = inv(dt)
    b10diff2invdt = -2 * invdt
    c10diff2invdt2 = 2 * invdt^2 # = -c00diff2 * inv(dt)^2
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        },
        idxs::Nothing, T::Type{Val{0}}, differential_vars::Nothing
    )
    @ssprkpre0
    @inbounds @.. broadcast = false y₀ * c00 + y₁ * c10 + k[1] * b10dt
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        }, idxs,
        T::Type{Val{0}}, differential_vars::Nothing
    )
    @ssprkpre0
    @views @.. broadcast = false y₀[idxs] * c00 + y₁[idxs] * c10 + k[1][idxs] * b10dt
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        },
        idxs::Nothing, T::Type{Val{0}}, differential_vars::Nothing
    )
    @ssprkpre0
    @inbounds @.. broadcast = false out = y₀ * c00 + y₁ * c10 + k[1] * b10dt
    out
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        }, idxs,
        T::Type{Val{0}}, differential_vars::Nothing
    )
    @ssprkpre0
    @views @.. broadcast = false out = y₀[idxs] * c00 + y₁[idxs] * c10 + k[1][idxs] * b10dt
    out
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        },
        idxs::Nothing, T::Type{Val{1}}, differential_vars::Nothing
    )
    @ssprkpre1
    @inbounds @.. broadcast = false (y₁ - y₀) * c10diffinvdt + k[1] * b10diff
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        }, idxs,
        T::Type{Val{1}}, differential_vars::Nothing
    )
    @ssprkpre1
    @views @.. broadcast = false (y₁[idxs] - y₀[idxs]) * c10diffinvdt + k[1][idxs] * b10diff
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        },
        idxs::Nothing, T::Type{Val{1}}, differential_vars::Nothing
    )
    @ssprkpre1
    @inbounds @.. broadcast = false out = (y₁ - y₀) * c10diffinvdt + k[1] * b10diff
    out
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        }, idxs,
        T::Type{Val{1}}, differential_vars::Nothing
    )
    @ssprkpre1
    @views @.. broadcast = false out = (y₁[idxs] - y₀[idxs]) * c10diffinvdt +
        k[1][idxs] * b10diff
    out
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        },
        idxs::Nothing, T::Type{Val{2}}, differential_vars::Nothing
    )
    @ssprkpre2
    @inbounds @.. broadcast = false (y₁ - y₀) * c10diff2invdt2 + k[1] * b10diff2invdt
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        }, idxs,
        T::Type{Val{2}}, differential_vars::Nothing
    )
    @ssprkpre2
    @views @.. broadcast = false (y₁[idxs] - y₀[idxs]) *
        c10diff2invdt2 + k[1][idxs] * b10diff2invdt
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        },
        idxs, T::Type{Val{2}}, differential_vars::Nothing
    )
    @ssprkpre2
    @inbounds @.. broadcast = false out = (y₁[idxs] - y₀[idxs]) * c10diff2invdt2 +
        k[1][idxs] * b10diff2invdt
    out
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::Union{
            SSPRK22ConstantCache, SSPRK22Cache,
            SSPRK33ConstantCache, SSPRK33Cache,
            SSPRK43ConstantCache, SSPRK43Cache,
            SSPRK432ConstantCache, SSPRK432Cache,
        },
        idxs::Nothing, T::Type{Val{2}}, differential_vars::Nothing
    )
    @ssprkpre2
    @inbounds @.. broadcast = false out = (y₁ - y₀) * c10diff2invdt2 + k[1] * b10diff2invdt
    out
end
